/* based on the tutorial for the PE / C68 */
/* No benefit should be done with this soft */
/* This program is free : no charge, even for copying or anything else */
/* Any alteration is at your own risk */
/* Any use too! */

#include <qdos.h>
#include <qptr.h>
#include <string.h>
#include <libsprt.h>
#include <xmenu.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "main.h"
#include "demo.h"
#include "couleur.h"
#include "multilang.h"
#include "color.h"


extern long Colour_Select(const colourSet * color_code, unsigned short previous);
extern long Colour256_Select(const colourSet * color_code, unsigned short previous);

long wm_vectr=0;
#define min(a,b) ((a)<(b)?(a):(b))
                                    /* for new C68 , use _condetails.. */
short *pM256back,*pQ40back,*pM4back,*pM8back;
struct WINDOWDEF _condetails = 
                    { (char) 0,(char) 0,(char)0,(char)4 ,
                      (short)2,(short)1,(short)0,(short)0};

unsigned int dis_x,dis_y;
char _conname[] = "con_2x1a0x0";      /* mask startup problems, for old one */
char *_endmsg  = NULL;                /* and stop when I say */
#define JG_PROG_NAME "Editeur de Sprite pour Q40"
char _PROG_NAME[] = JG_PROG_NAME;
int not_q40;
int editor_mode;
extern unsigned short sp40_col;
extern unsigned char sp256_col;
extern struct WM_blob sp40_blob,ms40_blob,sp40_point;
extern struct WM_pattern sp40_patt,ms40_unset,ms40_set,sp_pnoir,sp_prouge;
extern struct WM_sprite logo;

static QD_TEXT(3) hauteur,largeur;
static QD_TEXT(3) text_r,text_w,text_g,text_b;
static long ACOEUR(), AMOVE(), ARESIZE(), AMODE(), AZZZ(), AWAKE();
static long ADRAW1(),AHIT1(),LOADQ(),LOADM(),SAVEB();
static long ADRAW0(),AHIT0();
static long ATI(),SAVE(),LOAD();
static long QL4(), Q40(),QL8(),Q256();
struct WM_action ati={JSR,wm_actli, ATI};
struct WM_action save={JSR,wm_actli, SAVE};
struct WM_action saveb={JSR,wm_actli, SAVEB};

struct WM_action load={JSR,wm_actli, LOAD};
struct WM_action ahit1={JSR,wm_hitaw, AHIT1};
struct WM_action ahit0={JSR,wm_hitaw, AHIT0};
struct WM_action ql4 = {JSR, wm_actli, QL4};
struct WM_action ql8 = {JSR, wm_actli, QL8};
struct WM_action q40 = {JSR, wm_actli, Q40};
struct WM_action q256 = {JSR, wm_actli, Q256};
struct WM_action loadq = {JSR, wm_actli, LOADQ};
struct WM_action mload = {JSR, wm_actli, LOADM};


struct WM_action acoeur = {JSR, wm_actli, ACOEUR};
struct WM_action amove = {JSR, wm_actli, AMOVE};
struct WM_action awake = {JSR, wm_actli, AWAKE};
struct WM_action azzz = {JSR, wm_actli, AZZZ};
struct WM_action aresize = {JSR, wm_actli, ARESIZE};
struct WM_action amode = {JSR, wm_actli, AMODE};

struct WM_action adraw1 = {JSR, wm_drwaw, ADRAW1};
struct WM_action adraw0 = {JSR, wm_drwaw, ADRAW0};

unsigned long the_sprite[GRIDY][GRIDX];
unsigned long the_mask[GRIDY][GRIDX];
int top,bottom,lefti,righti;
int sprite_with_mask = 0;

int mode8_top, mode8_left;

void update_demo()
{
short a,b;
unsigned int round;
unsigned int mx,my;
int i,j;
int cursor;
if (editor_mode == 40)
{
a=abs(lefti-righti);
b=abs(top-bottom);
if ((!a)||(!b))
 {
   return;
 }
mx=min(lefti,righti);
my=min(top,bottom);
sp40_xsize = a;
sp40_ysize = b;
round = (a+1) & 0xFFFE;
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i++)
{
  sp40_dpatt[cursor] = the_sprite[my+j][mx+i]>>16;
  sp40_dmask[cursor] = the_mask[my+j][mx+i]>>16 ? 0xFFFF: 0x0000;
  if (i>=a)
  {
    sp40_dpatt[cursor] = 0x0000;
    sp40_dmask[cursor] = 0x0000;
  }
  cursor++;

}
}
else if (editor_mode == 256)
{
a=abs(lefti-righti);
b=abs(top-bottom);
if ((!a)||(!b))
 {
   return;
 }
mx=min(lefti,righti);
my=min(top,bottom);
sp256_xsize = a;
sp256_ysize = b;
round = (a+3) & 0xFFFC;
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i++)
{
  sp256_dpatt[cursor] = ((the_sprite[my+j][mx+i] & 0x0000FE00)>>8)|
                        ((the_sprite[my+j][mx+i] & 0x00000080)>>7)  ;
  sp256_dmask[cursor] = (the_mask[my+j][mx+i]&0x0000FF00) ? 0xFF: 0x00;
  if (i>=a)
  {
    sp256_dpatt[cursor] = 0x00;
    sp256_dmask[cursor] = 0x00;
  }
  cursor++;

}
}

else if (editor_mode == 4)
{
a=abs(lefti-righti);
b=abs(top-bottom);
if ((!a)||(!b))
 {
   return;
 }
mx=min(lefti,righti);
my=min(top,bottom);
sp4_xsize = a;
sp4_ysize = b;
round = (a+15) & 0xFFF0;
for(cursor=0;cursor<600;cursor++)
{
  sp4_dpatt[cursor] = 0;
  sp4_dmask[cursor] =
                        0x0000;
}
cursor = 0;

for(j=0;j<b;j++)
for(i=0;i<round;i++)
{
  if (i<a) {
  sp4_dpatt[cursor] |= (the_sprite[my+j][mx+i] & 0x000101)<<(7-(i%8));
  sp4_dmask[cursor] |= (the_mask[my+j][mx+i] & 0x00000F) ? (0x0101)<<(7-(i%8))
                          : 0x0000;
  }
  if ((i+1)%8==0) {cursor++;}

}
}
else
{
unsigned char cok;

a=abs(lefti-righti);
b=abs(top-bottom);
if ((!a)||(!b))
 {
   return;
 }
a = (a+1) & 0xFFFE;
mx=min(lefti,righti);
mode8_top= my=min(top,bottom);

mx &= 0xFFFE;
mode8_left=mx;

sp8_xsize = a;
sp8_ysize = b;
round = (a+3) & 0xFFFC;
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=2)
{
  cok = color_8to256( the_sprite[my+j][mx+i] );

  sp8_dpatt[cursor] = cok;
  sp8_dmask[cursor] = the_mask[my+j][mx+i] & 0x000000F0 ? 0xFF: 0x00;
  if (i>=a)
  {
    sp8_dpatt[cursor] = 0x00;
    sp8_dmask[cursor] = 0x00;
  }
  cursor++;
  sp8_dpatt[cursor] = cok;
  the_mask[my+j][mx+i+1] &=0xFFFFFF0F;
  the_mask[my+j][mx+i+1] |= the_mask[my+j][mx+i] & 0x000000F0;
  sp8_dmask[cursor] = the_mask[my+j][mx+i+1] & 0x000000F0 ? 0xFF: 0x00;
  if (i>=a)
  {
    sp8_dpatt[cursor] = 0x00;
    sp8_dmask[cursor] = 0x00;
  }
  cursor++;

}
}

}


void update_dimension()
{
char temp[4];
sprintf(temp,"%3.d",abs(top-bottom));
QD_STXT(hauteur,temp,strlen(temp));
sprintf(temp,"%3.d",abs(lefti-righti));
QD_STXT(largeur,temp,strlen(temp));
}
static update_couleur()
{
char temp[4];

sprintf(temp,"%3.d",coul_col & 0x0001);
QD_STXT(text_w,temp,strlen(temp));
sprintf(temp,"%3.d",(coul_col & 0x07C0)>>6);
QD_STXT(text_r,temp,strlen(temp));
sprintf(temp,"%3.d",(coul_col & 0xF800)>>11);
QD_STXT(text_g,temp,strlen(temp));
sprintf(temp,"%3.d",(coul_col & 0x003E)>>1);
QD_STXT(text_b,temp,strlen(temp));
}

sprite_rotate(int x, int y)
{
unsigned long partie;
unsigned long ecrase;
unsigned long transfer, keep;
int i,j,a,b,mx,my;

a=abs(lefti-righti);
mx=min(lefti,righti);
b=abs(top-bottom);
my=min(top,bottom);
colorpattern(editor_mode, &partie, &ecrase);
if (y)
{
for(i=mx;i<mx+a;i++)
{
  if (y>0) { transfer = the_sprite[my+b-1][i];
  for(j=my+b-1;j>my;j--)
  {
     keep = the_sprite[j-1][i];
     the_sprite[j][i] &= partie;
     keep &= ecrase;
     the_sprite[j][i] |= keep;
  }
  the_sprite[my][i] &= partie;
  transfer &= ecrase;
  the_sprite[my][i] |= transfer;
  }
  else {  transfer = the_sprite[my][i];
  for(j=my;j<my+b-1;j++)
  {
     keep = the_sprite[j+1][i];
     the_sprite[j][i] &= partie;
     keep &= ecrase;
     the_sprite[j][i] |= keep;
  }
  the_sprite[my+b-1][i] &= partie;
  transfer &= ecrase;
  the_sprite[my+b-1][i] |= transfer;
  }
 }
}
else
{
for(i=my;i<my+b;i++)
{
  if (x>0) { transfer = the_sprite[i][mx+a-1];
  for(j=mx+a-1;j>mx;j--)
  {
     keep = the_sprite[i][j-1];
     the_sprite[i][j] &= partie;
     keep &= ecrase;
     the_sprite[i][j] |= keep;
  }
  the_sprite[i][mx] &= partie;
  transfer &= ecrase;
  the_sprite[i][mx] |= transfer;
  }
  else {  transfer = the_sprite[i][mx];
  for(j=mx;j<mx+a-1;j++)
  {
     keep = the_sprite[i][j+1];
     the_sprite[i][j] &= partie;
     keep &= ecrase;
     the_sprite[i][j] |= keep;
  }
  the_sprite[i][mx+a-1] &= partie;
  transfer &= ecrase;
  the_sprite[i][mx+a-1] |= transfer;
  }
 }

}

}

sprite_trans(int x, int y)
{
unsigned long partie;
unsigned long ecrase;
unsigned long transfer, keep;
int i,j,a,b,mx,my;

switch(editor_mode)
{
  case 40:
         transfer = color_q40(coul_col);  break;
  case 4:
         transfer = color_ql4(coul_col); break;
  case 8:
         transfer = color_ql8(coul_col); break;
  case 256:
         transfer = color_256(coul_col); break;
}

a=abs(lefti-righti);
mx=min(lefti,righti);
b=abs(top-bottom);
my=min(top,bottom);
colorpattern(editor_mode, &partie, &ecrase);
if (y)
{
for(i=mx;i<mx+a;i++)
{
  if (y>0) {
  for(j=my+b-1;j>my;j--)
  {
     keep = the_sprite[j-1][i];
     the_sprite[j][i] &= partie;
     keep &= ecrase;
     the_sprite[j][i] |= keep;
  }
  the_sprite[my][i] &= partie;
  transfer &= ecrase;
  the_sprite[my][i] |= transfer;
  }
  else {
  for(j=my;j<my+b-1;j++)
  {
     keep = the_sprite[j+1][i];
     the_sprite[j][i] &= partie;
     keep &= ecrase;
     the_sprite[j][i] |= keep;
  }
  the_sprite[my+b-1][i] &= partie;
  transfer &= ecrase;
  the_sprite[my+b-1][i] |= transfer;
  }
 }
}
else
{
for(i=my;i<my+b;i++)
{
  if (x>0) {
  for(j=mx+a-1;j>mx;j--)
  {
     keep = the_sprite[i][j-1];
     the_sprite[i][j] &= partie;
     keep &= ecrase;
     the_sprite[i][j] |= keep;
  }
  the_sprite[i][mx] &= partie;
  transfer &= ecrase;
  the_sprite[i][mx] |= transfer;
  }
  else {
  for(j=mx;j<mx+a-1;j++)
  {
     keep = the_sprite[i][j+1];
     the_sprite[i][j] &= partie;
     keep &= ecrase;
     the_sprite[i][j] |= keep;
  }
  the_sprite[i][mx+a-1] &= partie;
  transfer &= ecrase;
  the_sprite[i][mx+a-1] |= transfer;
  }
 }

}

}


mask_rotate(int x, int y)
{
unsigned long partie;
unsigned long ecrase;
unsigned long transfer, keep;
int i,j,a,b,mx,my;

a=abs(lefti-righti);
mx=min(lefti,righti);
b=abs(top-bottom);
my=min(top,bottom);
maskpattern(editor_mode,&partie,&ecrase);
if (y)
{
for(i=mx;i<mx+a;i++)
{
  if (y>0) { transfer = the_mask[my+b-1][i];
  for(j=my+b-1;j>my;j--)
  {
     keep = the_mask[j-1][i];
     the_mask[j][i] &= partie;
     keep &= ecrase;
     the_mask[j][i] |= keep;
  }
  the_mask[my][i] &= partie;
  transfer &= ecrase;
  the_mask[my][i] |= transfer;
  }
  else {  transfer = the_mask[my][i];
  for(j=my;j<my+b-1;j++)
  {
     keep = the_mask[j+1][i];
     the_mask[j][i] &= partie;
     keep &= ecrase;
     the_mask[j][i] |= keep;
  }
  the_mask[my+b-1][i] &= partie;
  transfer &= ecrase;
  the_mask[my+b-1][i] |= transfer;
  }
 }
}
else
{
for(i=my;i<my+b;i++)
{
  if (x>0) { transfer = the_mask[i][mx+a-1];
  for(j=mx+a-1;j>mx;j--)
  {
     keep = the_mask[i][j-1];
     the_mask[i][j] &= partie;
     keep &= ecrase;
     the_mask[i][j] |= keep;
  }
  the_mask[i][mx] &= partie;
  transfer &= ecrase;
  the_mask[i][mx] |= transfer;
  }
  else {  transfer = the_mask[i][mx];
  for(j=mx;j<mx+a-1;j++)
  {
     keep = the_mask[i][j+1];
     the_mask[i][j] &= partie;
     keep &= ecrase;
     the_mask[i][j] |= keep;
  }
  the_mask[i][mx+a-1] &= partie;
  transfer &= ecrase;
  the_mask[i][mx+a-1] |= transfer;
  }
 }

}

}

mask_trans(int x, int y)
{
unsigned long partie;
unsigned long ecrase;
unsigned long transfer, keep;
int i,j,a,b,mx,my;

maskpattern(editor_mode,&partie,&transfer);

a=abs(lefti-righti);
mx=min(lefti,righti);
b=abs(top-bottom);
my=min(top,bottom);
ecrase = transfer;
if (y)
{
for(i=mx;i<mx+a;i++)
{
  if (y>0) {
  for(j=my+b-1;j>my;j--)
  {
     keep = the_mask[j-1][i];
     the_mask[j][i] &= partie;
     keep &= ecrase;
     the_mask[j][i] |= keep;
  }
  the_mask[my][i] &= partie;
  transfer &= ecrase;
  the_mask[my][i] |= transfer;
  }
  else {
  for(j=my;j<my+b-1;j++)
  {
     keep = the_mask[j+1][i];
     the_mask[j][i] &= partie;
     keep &= ecrase;
     the_mask[j][i] |= keep;
  }
  the_mask[my+b-1][i] &= partie;
  transfer &= ecrase;
  the_mask[my+b-1][i] |= transfer;
  }
 }
}
else
{
for(i=my;i<my+b;i++)
{
  if (x>0) {
  for(j=mx+a-1;j>mx;j--)
  {
     keep = the_mask[i][j-1];
     the_mask[i][j] &= partie;
     keep &= ecrase;
     the_mask[i][j] |= keep;
  }
  the_mask[i][mx] &= partie;
  transfer &= ecrase;
  the_mask[i][mx] |= transfer;
  }
  else {
  for(j=mx;j<mx+a-1;j++)
  {
     keep = the_mask[i][j+1];
     the_mask[i][j] &= partie;
     keep &= ecrase;
     the_mask[i][j] |= keep;
  }
  the_mask[i][mx+a-1] &= partie;
  transfer &= ecrase;
  the_mask[i][mx+a-1] |= transfer;
  }
 }

}

}

main()
{
   static struct WM_wstat ws =  /* window status area */
   {
     NULL,                  /* *wwork               point back to work def */
     NULL,                  /* *wdef                this was wdef */
     0,                     /* chid                 chan ID enclosing pointer */
     0,0,0,                 /* swnr, xpos, ypos     sub-window and ptr posn */
     0,0,                   /* kstk, kprs           key stroke and press */
     0,                     /* evnt                 event vector */
     0,0,0,0,               /* xsiz, ysiz, xorg, yorg  */
     0,0,                   /* ptpsx, ptpsy         pointer position (abs) */
     0x0221,0,0,          /* wmode, 2 spare       window mode and spare */

     NULL,                  /* *ciact               current item "action" */
     -1,                    /* citem                current item */
     0,0,0,                 /* cibrw, cipap, cispr  current item attr */
     0,0,0,0,               /* cihxs,ys, cihxo,yo   current item hit area */

     {0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0, 0,0, 0,00, 00,00,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0, 0,0,0,0}      /* litem[40]            loose item status */
   };


  static QD_TEXTI(Txt_4,"QL4");
  static QD_TEXTI(Txt_Q,"Q40");
  static QD_TEXTI(Txt_8,"QL8");
  static QD_TEXTI(Txt_6,"256");

  static QD_TEXTI(Txt_plus," + ");
  static QD_TEXTI(Txt_moins," - ");


#define wind_wid  (GRIDX*CASEX)    /* application sw size */
#define wind_hgt  (GRIDY*CASEY)
#define xt_wid    172+GRIDX*4     /* extra width of window */
#define xt_hgt    6
#define tot_wid  wind_wid+xt_wid
#define tot_hgt  wind_hgt+xt_hgt

#define xoff wind_wid+12
#define yoff 0 /* offset for the STANDARD 13 Litem */

#define min_wid  tot_wid     /* and limits */
#define min_hgt  tot_hgt
#define max_wid  tot_wid
#define max_hgt  tot_hgt

#define ninfw    1+4+2+4+1+2+1       /* number of information windows */
#define ninfo    1       /* number of information objects */
#define nlitm    102  /* number of loose items */
#define nappl    2       /* number of application sub-windows */

#define gen_wid(a) ((sizeof((a))-1)*6)



   static struct WM_info info[1+1] =   /* information objects */
   {
    {24,24,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_BLOB,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &coul_blob}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info extra[1+1] =   /* information objects */
   {
    {24,24,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_BLOB,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &xcoul_blob}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };



   static struct WM_info demoq40[1+1] =   /* information objects */
   {
    {GRIDX,GRIDY,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &sp40_demo}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };
   static struct WM_info demoq4[1+1] =   /* information objects */
   {
    {GRIDX,GRIDY,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &sp4_demo}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };
   static struct WM_info demoq8[1+1] =   /* information objects */
   {
    {GRIDX,GRIDY,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &sp8_demo}                /* *pobj                pointer to object */
    ,{-1}
   };

   static struct WM_info demoq256[1+1] =   /* information objects */
   {
    {GRIDX,GRIDY,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &sp256_demo}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info info_haut[1+1] =   /* information objects */
   {
    {24,10,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &hauteur}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info info_larg[1+1] =   /* information objects */
   {
    {24,10,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &largeur}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info info_w[1+1] =   /* information objects */
   {
    {24,10,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &text_w}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info info_r[1+1] =   /* information objects */
   {
    {24,10,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {7,0,0},         /* ink, cwid, chgt      character attributes */
     &text_r}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };
   static struct WM_info info_g[1+1] =   /* information objects */
   {
    {24,10,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &text_g}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info info_b[1+1] =   /* information objects */
   {
    {24,10,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {7,0,0},         /* ink, cwid, chgt      character attributes */
     &text_b}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info logooo[2+1] =   /* information objects */
   {
    {68,60,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &logo}                /* *pobj                pointer to object */

   , {64,60,            /* xsize, ysize         size */
     72,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &xmenu_logo}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info info_rotate[1+1] =   /* information objects */
   {
    {32,18,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &rotate}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_info info_translate[1+1] =   /* information objects */
   {
    {32,18,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_SPRITE,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &translate}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };
#define Q40BACK &(infw[1].borc)
#define M4BACK  &(infw[2].borc)
#define M8BACK  &(infw[5].borc)
#define M256BACK &(infw[13].borc)

   static struct WM_infw infw[ninfw+1] =  /* information window */
   {
    {24,24, /* xsize, ysize       size */
     xoff+4+32,yoff+2+14*12,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,0377,7,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */
#define IWCOLOUR 0x7FFFFFFE
   , {GRIDX,GRIDY, /* xsize, ysize       size */
     min_wid-(4+GRIDX)*2,2,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,1,1,          /* borw, borc, papr     border width/clr, paper */
     demoq40}                  /* *pobj                pointer to object list */
#define IWQ40 0x7FFFFFFD
   , {GRIDX,GRIDY, /* xsize, ysize       size */
     min_wid-(GRIDX+4)*3,2,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,1,1,          /* borw, borc, papr     border width/clr, paper */
     demoq4}                  /* *pobj                pointer to object list */
#define IWQL4 0x7FFFFFFB
   , {24,10, /* xsize, ysize       size */
     4+xoff+32*2,2+14*5+yoff,         /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     0,0,6,          /* borw, borc, papr     border width/clr, paper */
     info_haut}                  /* *pobj                pointer to object list */
#define IWHAUT 0x7FFFFFF7
   , {24,10, /* xsize, ysize       size */
     4+xoff+2*32,2+14*4+yoff,         /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     0,0,6,          /* borw, borc, papr     border width/clr, paper */
     info_larg}                  /* *pobj                pointer to object list */
#define IWLARG 0x7FFFFFEF
   , {GRIDX,GRIDY, /* xsize, ysize       size */
     min_wid-(GRIDX+4)*4,2,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,1,1,          /* borw, borc, papr     border width/clr, paper */
     demoq8}                  /* *pobj                pointer to object list */
#define IWQL8 0x7FFFFFDF
   , {24,10, /* xsize, ysize       size */
     xoff+4,yoff+2+14*10,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,0377,7,          /* borw, borc, papr     border width/clr, paper */
     info_w}                  /* *pobj                pointer to object list */
#define IWWHITE 0x7FFFFFBF
   , {24,10, /* xsize, ysize       size */
     xoff+4+32,yoff+2+14*10,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,0377,2,          /* borw, borc, papr     border width/clr, paper */
     info_r}                  /* *pobj                pointer to object list */
#define IWRED 0x7FFFFF7F
   , {24,10, /* xsize, ysize       size */
     xoff+4+32*2,yoff+2+14*10,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,0377,4,          /* borw, borc, papr     border width/clr, paper */
     info_g}                  /* *pobj                pointer to object list */
#define IWGREEN 0x7FFFFEFF
   , {24,10, /* xsize, ysize       size */
     xoff+4+32*3,yoff+2+14*10,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,0377,1,          /* borw, borc, papr     border width/clr, paper */
     info_b}                  /* *pobj                pointer to object list */
#define IWBLUE 0x7FFFFDFF
  ,  {136,60, /* xsize, ysize       size */
     min_wid-4-136,min_hgt-4-60,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,0,0,          /* borw, borc, papr     border width/clr, paper */
     logooo}                  /* *pobj                pointer to object list */


  ,  {32,18, /* xsize, ysize       size */
     xoff+4+32*2+12,yoff+2+14*14+4,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     0,0,7,          /* borw, borc, papr     border width/clr, paper */
     info_rotate}
                  /* *pobj                pointer to object list */
  ,  {32,18, /* xsize, ysize       size */
     xoff+4+32*2+12,yoff+2+14*20+4,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     0,0,7,          /* borw, borc, papr     border width/clr, paper */
     info_translate}                  /* *pobj                pointer to object list */
   , {GRIDX,GRIDY, /* xsize, ysize       size */
     min_wid-(GRIDX+4),2,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,1,1,          /* borw, borc, papr     border width/clr, paper */
     demoq256},                  /* *pobj                pointer to object list */
#define IW256 0x7FFFDFFF
    {24,24, /* xsize, ysize       size */
     xoff+4+32*3,yoff+2+14*12,           /* xorg, yorg           and origin */
     0,                     /* flag                 no clear + shadow */
     1,0377,7,          /* borw, borc, papr     border width/clr, paper */
     extra}                  /* *pobj                pointer to object list */
#define IWXTRA 0x7FFFBFFF

   ,{-1}                    /* end of array */
   };



   static struct WM_litm litm[nlitm+1] =   /* loose item */
   {
    {24,10,                 /* xsize, ysize         size */
     4+xoff,2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_COEUR,    /* type, skey           type and select key */
     &sp4_coeur,             /* *pobj                pointer to object */
     lit_coeur,              /* item                 item number */
     &acoeur}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+32*2+xoff,2+14+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_MOVE,    /* type, skey           type and select key */
     (void *)6,             /* *pobj                pointer to object */
     lit_move,              /* item                 item number */
     &amove}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+32*2+xoff,2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_RESIZE,    /* type, skey           type and select key */
     (void *)7,             /* *pobj                pointer to object */
     lit_resize,              /* item                 item number */
     &aresize}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+32+xoff,2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_ZZZ,    /* type, skey           type and select key */
     &sp4_zzz,             /* *pobj                pointer to object */
     lit_zzz,              /* item                 item number */
     &azzz}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+32+xoff,2+14+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_MODE,    /* type, skey           type and select key */
     (void *)3,             /* *pobj                pointer to object */
     lit_mode,              /* item                 item number */
     &amode}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,K_WAKE,    /* type, skey           type and select key */
     &sp4_wake,             /* *pobj                pointer to object */
     lit_wake,              /* item                 item number */
     &awake}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'H',    /* type, skey           type and select key */
     &bleft,             /* *pobj                pointer to object */
     lit_lleft,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'K',    /* type, skey           type and select key */
     &bup,             /* *pobj                pointer to object */
     lit_tup,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'J',    /* type, skey           type and select key */
     &bdown,             /* *pobj                pointer to object */
     lit_tdown,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*3,2+14*2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'L',    /* type, skey           type and select key */
     &bright,             /* *pobj                pointer to object */
     lit_lright,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*3+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'Y',    /* type, skey           type and select key */
     &rleft,             /* *pobj                pointer to object */
     lit_rleft,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*3+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'I',    /* type, skey           type and select key */
     &rup,             /* *pobj                pointer to object */
     lit_bup,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*3+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'U',    /* type, skey           type and select key */
     &rdown,             /* *pobj                pointer to object */
     lit_bdown,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*3,2+14*3+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'O',    /* type, skey           type and select key */
     &rright,             /* *pobj                pointer to object */
     lit_rright,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*6+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-3,'4',    /* type, skey           type and select key */
     &Txt_4,             /* *pobj                pointer to object */
     lit_4,              /* item                 item number */
     &ql4}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*6+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-3,'0',    /* type, skey           type and select key */
     &Txt_Q,             /* *pobj                pointer to object */
     lit_Q,              /* item                 item number */
     &q40}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+yoff+14*6,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-3,'8',    /* type, skey           type and select key */
     &Txt_8,             /* *pobj                pointer to object */
     lit_8,              /* item                 item number */
     &ql8}                /* *pact                pointer to action */



   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'N',    /* type, skey           type and select key */
     &coul_0,             /* *pobj                pointer to object */
     lit_noir,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'R',    /* type, skey           type and select key */
     &coul_2,             /* *pobj                pointer to object */
     lit_rouge,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'V',    /* type, skey           type and select key */
     &coul_4,             /* *pobj                pointer to object */
     lit_vert,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*3,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'B',    /* type, skey           type and select key */
     &coul_7,             /* *pobj                pointer to object */
     lit_blanc,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*8+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'E',    /* type, skey           type and select key */
     &coul_1,             /* *pobj                pointer to object */
     lit_bleu,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*8+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'M',    /* type, skey           type and select key */
     &coul_3,             /* *pobj                pointer to object */
     lit_magenta,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*8+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'C',    /* type, skey           type and select key */
     &coul_5,             /* *pobj                pointer to object */
     lit_cyan,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*3,2+14*8+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'A',    /* type, skey           type and select key */
     &coul_6,             /* *pobj                pointer to object */
     lit_jaune,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*9+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_plus,             /* *pobj                pointer to object */
     lit_rplus,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*9+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_plus,             /* *pobj                pointer to object */
     lit_gplus,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*3,2+14*9+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_plus,             /* *pobj                pointer to object */
     lit_bplus,              /* item                 item number */
     &ati}                /* *pact                pointer to action */


   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*9+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_plus,             /* *pobj                pointer to object */
     lit_wplus,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*11+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_moins,             /* *pobj                pointer to object */
     lit_rmoins,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*11+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_moins,             /* *pobj                pointer to object */
     lit_gmoins,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*3,2+14*11+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_moins,             /* *pobj                pointer to object */
     lit_bmoins,              /* item                 item number */
     &ati}                /* *pact                pointer to action */


   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*11+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT,0,    /* type, skey           type and select key */
     &Txt_moins,             /* *pobj                pointer to object */
     lit_wmoins,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24+32,10,                 /* xsize, ysize         size */
     4+xoff+32*6,2+14*13+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sauvegarde,             /* *pobj                pointer to object */
     lit_save,              /* item                 item number */
     &save}                /* *pact                pointer to action */
   , {24+32,10,                 /* xsize, ysize         size */
     4+xoff+32*4,2+14*13+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sauvegardeb,             /* *pobj                pointer to object */
     lit_saveb,              /* item                 item number */
     &saveb}                /* *pact                pointer to action */
   , {24+32,10,                 /* xsize, ysize         size */
     4+xoff+32*6,2+yoff+14*8,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &chargement,             /* *pobj                pointer to object */
     lit_load,              /* item                 item number */
     &load}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*14+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &left,             /* *pobj                pointer to object */
     lit_rotleft,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*20+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &left,             /* *pobj                pointer to object */
     lit_transleft,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*15+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &right,             /* *pobj                pointer to object */
     lit_rotright,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*21+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &right,             /* *pobj                pointer to object */
     lit_transright,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*1,2+14*14+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &up,             /* *pobj                pointer to object */
     lit_rotup,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*1,2+14*20+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &up,             /* *pobj                pointer to object */
     lit_transup,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*15+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &down,             /* *pobj                pointer to object */
     lit_rotdown,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*21+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &down,             /* *pobj                pointer to object */
     lit_transdown,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*4+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &bxquery,             /* *pobj                pointer to object */
     lit_bxquery,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*5+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &byquery,             /* *pobj                pointer to object */
     lit_byquery,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*4+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &rxquery,             /* *pobj                pointer to object */
     lit_rxquery,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32,2+14*5+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &ryquery,             /* *pobj                pointer to object */
     lit_ryquery,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*6,2+14*6+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &spq40toql8,             /* *pobj                pointer to object */
     lit_40to8,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*6,2+14*5+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &spq40toql4,             /* *pobj                pointer to object */
     lit_40to4,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*4,2+14*6+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &spql8toq40,             /* *pobj                pointer to object */
     lit_8to40,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*5,2+14*5+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &spql4toq40,             /* *pobj                pointer to object */
     lit_4to40,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*3,2+14*16+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk4to40,             /* *pobj                pointer to object */
     lit_m4to40,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*2,2+14*16+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk40to4,             /* *pobj                pointer to object */
     lit_m40to4,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*4,2+14*17+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk8to40,             /* *pobj                pointer to object */
     lit_m8to40,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*2,2+14*17+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk40to8,             /* *pobj                pointer to object */
     lit_m40to8,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24+32,10,                 /* xsize, ysize         size */
     4+xoff+32*4,2+yoff+14*8,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &picload,             /* *pobj                pointer to object */
     lit_loadq,              /* item                 item number */
     &loadq}                /* *pact                pointer to action */
   , {24+32,10,                 /* xsize, ysize         size */
     min_wid-4-32*2,2+yoff+14*19,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mpic,             /* *pobj                pointer to object */
     lit_mload,              /* item                 item number */
     &mload}                /* *pact                pointer to action */


   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*5,2+yoff+14*6,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp4to8,             /* *pobj                pointer to object */
     lit_4to8,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*3,2+yoff+14*17,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp4to8,             /* *pobj                pointer to object */
     lit_m4to8,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*4,2+yoff+14*5,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp8to4,             /* *pobj                pointer to object */
     lit_8to4,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*4,2+yoff+14*16,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp8to4,             /* *pobj                pointer to object */
     lit_m8to4,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*4,6+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_0,             /* *pobj                pointer to object */
     lit_bnoir,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*3,6+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_2,             /* *pobj                pointer to object */
     lit_brouge,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*2,6+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_4,             /* *pobj                pointer to object */
     lit_bvert,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32,6+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_7,             /* *pobj                pointer to object */
     lit_bblanc,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*4,6+14+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_1,             /* *pobj                pointer to object */
     lit_bbleu,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*3,6+14+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_3,             /* *pobj                pointer to object */
     lit_bmagenta,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*2,6+14+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_5,             /* *pobj                pointer to object */
     lit_bcyan,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32,6+14+GRIDY+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &coul_6,             /* *pobj                pointer to object */
     lit_bjaune,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {64,48,                 /* xsize, ysize         size */
     4+xoff+32*4,2+yoff+14*9,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_s_paint,             /* *pobj                pointer to object */
     lit_colorchoice,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff,2+14*14+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &left,             /* *pobj                pointer to object */
     lit_mrotleft,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff,2+14*20+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &left,             /* *pobj                pointer to object */
     lit_mtransleft,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff+32,2+14*15+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &right,             /* *pobj                pointer to object */
     lit_mrotright,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff+32,2+14*21+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &right,             /* *pobj                pointer to object */
     lit_mtransright,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff+32*1,2+14*14+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &up,             /* *pobj                pointer to object */
     lit_mrotup,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff+32*1,2+14*20+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &up,             /* *pobj                pointer to object */
     lit_mtransup,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff,2+14*15+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &down,             /* *pobj                pointer to object */
     lit_mrotdown,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*4+xoff,2+14*21+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &down,             /* *pobj                pointer to object */
     lit_mtransdown,              /* item                 item number */
     &ati}                /* *pact                pointer to action */


   , {64,48,                 /* xsize, ysize         size */
     4+32*4+72+xoff,2+14*9+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_s_kcontrol,             /* *pobj                pointer to object */
     lit_color256,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*3+xoff,2+14*6+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-3,'6',    /* type, skey           type and select key */
     &Txt_6,             /* *pobj                pointer to object */
     lit_256,              /* item                 item number */
     &q256}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*7+xoff,2+14*5+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp256toql4,             /* *pobj                pointer to object */
     lit_256to4,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*7+xoff,2+14*6+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp256toql8,             /* *pobj                pointer to object */
     lit_256to8,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*7+xoff,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp256toq40,             /* *pobj                pointer to object */
     lit_256to40,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*5+xoff,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &spql4to256,             /* *pobj                pointer to object */
     lit_4to256,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*4,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &spql8to256,             /* *pobj                pointer to object */
     lit_8to256,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+32*6+xoff,2+14*7+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &spq40to256,             /* *pobj                pointer to object */
     lit_40to256,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32,2+14*16+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk256to4,             /* *pobj                pointer to object */
     lit_m256to4,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32,2+14*17+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk256to8,             /* *pobj                pointer to object */
     lit_m256to8,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32,2+14*18+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk256toq40,             /* *pobj                pointer to object */
     lit_m256to40,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*3,2+14*18+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk4to256,             /* *pobj                pointer to object */
     lit_m4to256,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*4,2+14*18+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mk8to256,             /* *pobj                pointer to object */
     lit_m8to256,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*2,2+14*18+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &mkq40to256,             /* *pobj                pointer to object */
     lit_m40to256,              /* item                 item number */
     &ati}               /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32,2+14*20+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_c2m,             /* *pobj                pointer to object */
     lit_c2m,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*4,2+14*20+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_w2m,             /* *pobj                pointer to object */
     lit_w2m,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*12+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_fill,             /* *pobj                pointer to object */
     lit_fill,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff,2+14*13+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_invmask,             /* *pobj                pointer to object */
     lit_invcol,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*12+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_xchange,             /* *pobj                pointer to object */
     lit_xchange,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     4+xoff+32*2,2+14*13+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_replace,             /* *pobj                pointer to object */
     lit_replace,              /* item                 item number */
     &ati}                /* *pact                pointer to action */


   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*3,14*20+2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'S',    /* type, skey           type and select key */
     &smask,             /* *pobj                pointer to object */
     lit_Set,              /* item                 item number */
     &ati}                /* *pact                pointer to action */
   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*2,2+14*20+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,'D',    /* type, skey           type and select key */
     &dmask,             /* *pobj                pointer to object */
     lit_Unset,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   , {24,10,                 /* xsize, ysize         size */
     min_wid-4-32*3,14*19+2+yoff,         /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_SPRITE,0,    /* type, skey           type and select key */
     &sp_invmask,             /* *pobj                pointer to object */
     lit_invmask,              /* item                 item number */
     &ati}                /* *pact                pointer to action */

   ,{-1}                    /* end of array */
   };

   static WM_appw_t aw0 = /* application sub-window */
   {
     wind_wid+2,wind_hgt+1,  /* xsize, ysize         size */
     4,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,5,0377,   /* borw, borc, papr     border width/clr, paper */
     NULL,       /* *pspr                pointer to sprite */

     &adraw0,                /* *draw                draw routine */
     &ahit0,                 /* *hit                 hit routine */
     NULL,                  /* *ctrl                control routine */
     0,0,                   /* nxsc, nysc           max x,y sections */
     K_TAB,0,0,             /* skey, 2 spare        selection keystroke */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     NULL                       /* *pstat               wind status area (C68) */
   };

   static struct WM_appw aw1 = /* application sub-window */
   {
     GRIDX*2+2,GRIDY*2+1,  /* xsize, ysize         size */
     min_wid-GRIDX*2-4,GRIDY+6+14*2+yoff,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     1,6,7,   /* borw, borc, papr     border width/clr, paper */
     NULL,       /* *pspr                pointer to sprite */

     &adraw1,                /* *draw                draw routine */
     &ahit1,                 /* *hit                 hit routine */
     NULL,                  /* *ctrl                control routine */
     0,0,                   /* nxsc, nysc           max x,y sections */
     'A',0,0,             /* skey, 2 spare        selection keystroke */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     NULL                       /* *pstat               wind status area (C68) */
   };
   static WM_appl_t wappl[nappl+1]={&aw0,&aw1,NULL};

   static WM_WSCALE(ninfw+ninfo+nlitm+nappl) wsc =
                               {min_wid,min_hgt,max_wid,max_hgt,2,1,
                                {
                                 {0,0,8,0}, /* infw(0) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(1) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(2) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(3) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(4) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(5) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(6) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(7) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(8) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(8) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* infw(8) */
                                 {0,0,0,0}, /* rose sprite */
                                 {0,0,8,0}, /* Litem(0) */
                                 {0,0,8,0},
                                 {0,0,8,0},

                                 {0,0,8,0},
                                 {0,0,8,0},
                                 {0,0,8,0},
                                 {0,0,0,0},
                                 {0,0,0,0}
}};

   static struct WM_wwork ww = /* window working definition */
   {
     &ws,                   /* *wstat;              pointer to status area */
     &wsc,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     wappl,                  /* *splst               pointer to sprite list */

     tot_wid,tot_hgt,       /* xsize, ysize         size */
     wind_wid-4,0,         /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,CL_MBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,CL_MHIGH,            /* curw, curc           current item width/clr */

     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     CL_MPAVBL,CL_MIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     CL_MPSLCT,CL_MISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     1,1,infw,      /* ninfo, ninob, *pinfo info winds */
     nlitm,litm,            /* nlitm, *plitm        loose items */
     2,wappl             /* nappl  *pappl        appl winds */
   };



   short jg_mode,jg_type;
   jg_mode =-1;
   jg_type=-1;
   pQ40back = Q40BACK;
   pM4back = M4BACK;
   pM8back = M8BACK;
   pM256back = M256BACK;
   mt_dmode(&jg_mode,&jg_type);

   ws.litem[lit_mode]= 0x11;

   if ((Get_NativeForm() == 0x0221)
     && (DisplayYSize() == 512))
   {
      not_q40 = 0;
   }
   else if (((Get_NativeForm() & 0xFF00) != 0x0200)
     || (DisplayYSize() < tot_hgt)
     || (DisplayXSize() < tot_wid)
     )
   {
      if (((Get_NativeForm() & 0xFF00) != 0x0200))
      {
        Startup_Report(DefaultColourSet(),mess[MS_MCOLOR][conf_lang]);
      }
      else
      {
        Startup_Report(DefaultColourSet(),mess[MS_SSIZE][conf_lang]);
      }
      exit(-19);
   }
   else
   {
      not_q40 = 1;
      if (initial_mode == 40)
      {
         initial_mode = 0;
      }
      ws.litem[lit_Q]=0x11;
      ws.litem[lit_40to8]=0x11;
      ws.litem[lit_40to4]=0x11;
      ws.litem[lit_8to40]=0x11;
      ws.litem[lit_4to40]=0x11;
      ws.litem[lit_m4to40]=0x11;
      ws.litem[lit_m40to4]=0x11;
      ws.litem[lit_m40to8]=0x11;
      ws.litem[lit_m8to40]=0x11;
      ws.litem[lit_256to40]=0x11;
      ws.litem[lit_40to256]=0x11;
      ws.litem[lit_m256to40]=0x11;
      ws.litem[lit_m40to256]=0x11;


   }
   info[0].attr.comb = &coul_patt;
   extra[0].attr.comb = &xcoul_patt;

{int i,j;
for(i=0;i<GRIDX;i++)
for(j=0;j<GRIDY;j++)
{
the_sprite[j][i] = 0xFFFFFFFF;
the_mask[j][i] =  0xFFFFFFFF ;
}
}
   top = 0;
   bottom = initial_haut;
   lefti = 0;
   righti = initial_larg;
   editor_mode = initial_mode;
   if (!editor_mode) editor_mode=256;

if (editor_mode == 8)
{
   lefti &= 0xFE;
   righti = (righti +1) &0xFE;
  { int i;
 ws.litem[lit_color256]=0x11;
   ws.litem[lit_colorchoice]=0x11;
  for(;i<lit_noir+16;i++)
  ws.litem[i]=0x11;
}}

if (editor_mode == 4)
{ int i;
 ws.litem[lit_color256]=0x11;
   ws.litem[lit_colorchoice]=0x11;
  for(;i<lit_noir+16;i++)
   ws.litem[i]=0x11;
}
if (editor_mode == 256)
{
 ws.litem[lit_colorchoice]=0x11;
}
   update_demo();
   update_dimension();
   update_couleur();
   SetWindowColour(&ww,DefaultColourSet());
   SetInfoColour(&infw[4],DefaultColourSet());
   SetInfoColour(&infw[3],DefaultColourSet());
   ww.chid=fgetchid(stdout);
   if (!(wm_vectr = (long) wm_findv(ww.chid))) exit (-1);

   ws.wwork = &ww;        /* set cross reference */
   LimitGeometry(&ww,1024,512);
   wm_prpos (&ww,-1,-1);
   wm_wdraw (&ww);
   
   while (!wm_rptr(&ww))
{
 if (ws.evnt & PT_WSIZE) re_size (&ww,lit_resize);
 if (ws.evnt & PT_ZZZZ) {
switch(conf_bouton)
{
case 0: Menu_Button_Text(DefaultColourSet(),&ww,_PROG_NAME);
        break;
default: Menu_Button_Logo(DefaultColourSet(),&ww,&sp_pixmap);
        break;
}
}
 if (ws.evnt & PT_CAN) exit(0);
}
   exit (-1);                                                
}

/**
*   Loose Menu Item Action routines
**/

long ACT(wwk,li) struct WM_wwork *wwk; struct WM_litm *li;
{
   return li->skey+14;      /* calculate event for selection key */
}

static long AMOVE(wwk) struct WM_wwork *wwk;
{
   short dx,dy;
   wwk->wstat->evnt |= PT_WMOVE;   /* set event bit for wm_chwin */
   wm_chwin (wwk,&dx,&dy);         /* move window */
   return lit_reset (wwk,lit_move); /* and return */
}

static long AWAKE(wwk) struct WM_wwork *wwk;
{
update_demo();
wm_wdraw(wwk);
   return lit_reset (wwk,lit_wake); /* and return */
}

static void une_case(struct WM_wwork * wwk, char i,char j)
{
int k;
 switch(editor_mode)
 {
  case 40: sp40_col = color_q40toq40(the_sprite[j][i]); break;
  case 256: sp40_col = color_256toq40(the_sprite[j][i]); break;
  case 4: sp40_col = color_4toq40(the_sprite[j][i]); break;
  case 8: sp40_col = color_8toq40(the_sprite[j][i]); break;
 }
 sp256_col = color_q40to256(sp40_col);
 if (not_q40) { iop_wspt(wwk->chid,-1,i*CASEX+1,j*CASEY+1,&sp_center);}
 iop_wblb(wwk->chid,-1,i*CASEX+1,j*CASEY+1,&sp40_blob,&sp40_patt);

}

static long ADRAW0 (wwk, apw) struct WM_wwork *wwk; struct WM_appw *apw;
{

char i,j;

for(j=0;j<GRIDY;j++)
for(i=0;i<GRIDX;i++)
{
    une_case(wwk,i,j);
}
if (sprite_with_mask)
{ unsigned long partie,dummy;
maskpattern(editor_mode, &dummy, &partie);

for(i=0;i<GRIDX;i++)
for(j=0;j<GRIDY;j++)
{
   if (the_mask[j][i] & partie)
   {
      iop_wblb(wwk->chid,-1,i*CASEX+1,j*CASEY+1,&ms40_blob,&ms40_set);
   }
   else
   {
      iop_wblb(wwk->chid,-1,i*CASEX+1,j*CASEY+1,&ms40_blob,&ms40_unset);
   }
}
}

   iop_lblb(wwk->chid,-1,0,top*CASEY,GRIDX*CASEX+1,top*CASEY,&sp40_point,
                  &sp_pnoir);
   iop_lblb(wwk->chid,-1,lefti*CASEX,GRIDY*CASEY+1,lefti*CASEX,0,&sp40_point,
                  &sp_pnoir);

   iop_lblb(wwk->chid,-1,0,bottom*CASEY,GRIDX*CASEX+1,bottom*CASEY,&sp40_point,
                  &sp_prouge);
   iop_lblb(wwk->chid,-1,righti*CASEX,GRIDY*CASEY+1,righti*CASEX,0,&sp40_point,
                  &sp_prouge);


   return 0;
}

static long ADRAW1 (wwk, apw) struct WM_wwork *wwk; struct WM_appw *apw;
{
char i,j;
unsigned long partie,dummy;

maskpattern(editor_mode,&dummy,&partie);

for(i=0;i<GRIDX;i++)
for(j=0;j<GRIDY;j++)
{
   if (the_mask[j][i] & partie)
   {
      iop_wblb(wwk->chid,-1,i*2+1,j*2+1,&sp40_point,&ms40_set);
   }
   else
   {
      iop_wblb(wwk->chid,-1,i*2+1,j*2+1,&sp40_point,&ms40_unset);
   }
}
   iop_lblb(wwk->chid,-1,0,top*2,GRIDX*2+1,top*2,&sp40_point,
                  &sp_pnoir);
   iop_lblb(wwk->chid,-1,lefti*2,GRIDY*2+1,lefti*2,0,&sp40_point,
                  &sp_pnoir);

   iop_lblb(wwk->chid,-1,0,bottom*2,GRIDX*2+1,bottom*2,&sp40_point,
                  &sp_prouge);
   iop_lblb(wwk->chid,-1,righti*2,GRIDY*2+1,righti*2,0,&sp40_point,
                  &sp_prouge);


   return 0;
}

static long AZZZ(wwk) struct WM_wwork *wwk;
 { 
   lit_reset(wwk,lit_zzz);
   return PT__ZZZZ;
 }

static long ACOEUR(wwk) struct WM_wwork *wwk;
 {
          lit_reset(wwk,lit_coeur);
          exit(0);
          return 0;
}
static long ARESIZE(wwk) struct WM_wwork *wwk;
 {
          lit_reset(wwk,lit_resize);
          return PT__WSIZ;
}
static long AMODE(wwk) struct WM_wwork *wwk;
 {
   short jg_mode,jg_type;

          lit_reset(wwk,lit_mode);

   jg_mode =-1;
   jg_type=-1;
   mt_dmode(&jg_mode,&jg_type);
   if (jg_mode!=8) { jg_mode=8; mt_dmode(&jg_mode,&jg_type);}
          else { jg_mode=4; mt_dmode(&jg_mode,&jg_type);}
   wm_wdraw (wwk);

          return 0;
}


static long ATI(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{

    switch(li->item)
    {

   case lit_tup:
   if (top) { top--; update_dimension(); }


   break;

   case lit_tdown:
   if (top<GRIDY) { top++;update_dimension(); }

   break;
   case lit_bup:
   if (bottom) { bottom--;update_dimension(); }
   break;

   case lit_bdown:
   if (bottom<GRIDY) { bottom++;update_dimension(); }

   break;
   case lit_lleft:
   if (editor_mode == 8)
    {
   if (lefti>1) { lefti-=2;update_dimension(); }
    }
    else
    {
   if (lefti) { lefti--;update_dimension(); }
    }

   break;
   case lit_lright:
   if (editor_mode == 8)
   {
     if (lefti<GRIDX-1) { lefti+=2;update_dimension(); }
   }
   else
   {
     if (lefti<GRIDX) { lefti++;update_dimension(); }
   }

   break;
   case lit_rleft:
   if (editor_mode == 8)
   {
   if (righti>1) { righti-=2;update_dimension(); }
   }
   else {
   if (righti) { righti--;update_dimension(); }
   }

   break;
   case lit_rright:
   if (editor_mode == 8)
   {
   if (righti<GRIDX-1) { righti+=2;update_dimension(); }
   }
   else
   {
   if (righti<GRIDX) { righti++;update_dimension(); }
   }
   break;

   case lit_Set:
   {
      unsigned long ddd,dummy;
      int i,j,k,l,a,b;
      i=min(top,bottom);
      j=top+bottom-i;
      k=min(lefti,righti);
      l=lefti+righti-k;
      maskpattern(editor_mode,&dummy,&ddd);

      for(a=i;a<j;a++)
      for(b=k;b<l;b++)
         the_mask[a][b] |= ddd;
   }
   break;
   case lit_Unset:
   {
      unsigned long ddd,dummy;
      int i,j,k,l,a,b;
      i=min(top,bottom);
      j=top+bottom-i;
      k=min(lefti,righti);
      l=lefti+righti-k;
      maskpattern(editor_mode,&ddd,&dummy);

      for(a=i;a<j;a++)
      for(b=k;b<l;b++)
         the_mask[a][b] &= ddd;
   }
   break;
   case lit_noir: coul_col = 0x0000; break;
   case lit_bleu: coul_col = 0x003E; break;
   case lit_rouge: coul_col = 0x07C0; break;
   case lit_magenta: coul_col = 0x07FF; break;
   case lit_vert: coul_col = 0xF800; break;
   case lit_cyan: coul_col = 0xF83F; break;
   case lit_jaune: coul_col = 0xFFC1; break;
   case lit_blanc: coul_col = 0xFFFF; break;

#define colplus(a,b,d) {unsigned short c = coul_col; \
                    c &= (a) ; \
                    coul_col &= (d);   \
                    c += (b);           \
                    c &= (a);           \
                    coul_col |= c; }

#define colmoins(a,b,d) {unsigned short c = coul_col; \
                    c &= (a) ; \
                    coul_col &= (d);   \
                    c -= (b);           \
                    c &= (a);           \
                    coul_col |= c; }

    case lit_rplus: colplus(0x07C0, 0x0040, 0xF83F) break;
    case lit_gplus: colplus(0xF800, 0x0800, 0x07FF) break;
    case lit_bplus: colplus(0x003E, 0x0002, 0xFFC1) break;
    case lit_wplus: colplus(0x0001, 0x0001, 0xFFFE) break;
    case lit_rmoins: colmoins(0x07C0, 0x0040, 0xF83F) break;
    case lit_gmoins: colmoins(0xF800, 0x0800, 0x07FF) break;
    case lit_bmoins: colmoins(0x003E, 0x0002, 0xFFC1) break;
    case lit_wmoins: colmoins(0x0001, 0x0001, 0xFFFE) break;

    case lit_rotleft:   sprite_rotate(-1,0); if (editor_mode == 8) { sprite_rotate(-1,0);} update_demo();  break;
    case lit_rotright:  sprite_rotate(1,0); if (editor_mode == 8) { sprite_rotate(1,0); } update_demo(); break;
    case lit_rotup:     sprite_rotate(0,-1); update_demo(); break;
    case lit_rotdown:   sprite_rotate(0,1); update_demo(); break;

    case lit_transleft:  sprite_trans(-1,0); if (editor_mode == 8) { sprite_trans(-1,0); } update_demo(); break;
    case lit_transright: sprite_trans(1,0); if (editor_mode ==8 ) { sprite_trans(1,0); } update_demo(); break;
    case lit_transup:    sprite_trans(0,-1); update_demo(); break;
    case lit_transdown:  sprite_trans(0,1); update_demo(); break;


    case lit_mrotleft:   mask_rotate(-1,0); if (editor_mode == 8) { sprite_rotate(-1,0);} update_demo();  break;
    case lit_mrotright:  mask_rotate(1,0); if (editor_mode == 8) { sprite_rotate(1,0); } update_demo(); break;
    case lit_mrotup:     mask_rotate(0,-1); update_demo(); break;
    case lit_mrotdown:   mask_rotate(0,1); update_demo(); break;

    case lit_mtransleft:  mask_trans(-1,0); if (editor_mode == 8) { sprite_trans(-1,0); } update_demo(); break;
    case lit_mtransright: mask_trans(1,0); if (editor_mode ==8 ) { sprite_trans(1,0); } update_demo(); break;
    case lit_mtransup:    mask_trans(0,-1); update_demo(); break;
    case lit_mtransdown:  mask_trans(0,1); update_demo(); break;

    case lit_bxquery:
    {
       int answer;
       if (editor_mode != 8) {
       answer = Radio_Range_Select(DefaultColourSet(),
                             lefti,
                             mess[MS_HBPOS_T][conf_lang],
                             mess[MS_HBPOS_E][conf_lang],
                             0,GRIDX,1);
}
 else       {
       answer = Radio_Range_Select(DefaultColourSet(),
                             lefti/2,
                             mess[MS_HBPOS_T][conf_lang],
                             mess[MS_HBPOS_E][conf_lang],
                             0,GRIDX,2);
        if (answer != -1) {answer *=2;}
        }
        if (answer != -1) { lefti = answer; update_dimension(); }
    }
         break;
    case lit_rxquery:
    {
       int answer;
       if (editor_mode != 8)
       {
       answer = Radio_Range_Select(DefaultColourSet(),
                             righti,
                             mess[MS_HRPOS_T][conf_lang],
                             mess[MS_HBPOS_E][conf_lang],
                             0,GRIDX,1);
        }else
        {
       answer = Radio_Range_Select(DefaultColourSet(),
                             righti/2,
                             mess[MS_HRPOS_T][conf_lang],
                             mess[MS_HBPOS_E][conf_lang],
                             0,GRIDX,2);
        if (answer != -1) {answer *=2;}
        }
        if (answer != -1) { righti = answer; update_dimension(); }
    }
         break;
    case lit_byquery:
    {
       int answer;
       answer = Radio_Range_Select(DefaultColourSet(),
                             top,
                             mess[MS_VBPOS_T][conf_lang],
                             mess[MS_VBPOS_E][conf_lang],
                             0,GRIDY,1);
        if (answer != -1) { top = answer; update_dimension(); }
    }
         break;
    case lit_ryquery:
    {
       int answer;
       answer = Radio_Range_Select(DefaultColourSet(),
                             bottom,
                             mess[MS_VRPOS_T][conf_lang],
                             mess[MS_VBPOS_E][conf_lang],
                             0,GRIDY,1);
        if (answer != -1) { bottom = answer; update_dimension(); }
    }
         break;


    case lit_m4to256:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(4,256,&the_mask[j][i]);

      }
     i = editor_mode;
     editor_mode = 256;
     update_demo();
     editor_mode = i;
     }

    break;
  

    case lit_m4to40:
     {
      int i,j;
      unsigned long k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(4,40,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 40;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_m4to8:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i+=2)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(4,8,&the_mask[j][i]);

      }
     i = editor_mode;
     editor_mode = 8;
     update_demo();
     editor_mode = i;
     }

    break;
  


    case lit_m8to256:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(8,256,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 256;
     update_demo();
     editor_mode = i;
     }

    break;


    case lit_m8to40:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(8,40,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 40;
     update_demo();
     editor_mode = i;
     }

    break;
    case lit_m8to4:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(8,4,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 4;
     update_demo();
     editor_mode = i;
     }

    break;
    case lit_m40to256:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(40,256,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 256;
     update_demo();
     editor_mode = i;
     }

    break;


    case lit_m40to4:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(40,4,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 4;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_m40to8:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i+=2)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(40,8,&the_mask[j][i]);

      }
     i = editor_mode;
     editor_mode = 8;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_m256to4:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(256,4,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 4;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_m256to8:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i+=2)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(256,8,&the_mask[j][i]);

      }
     i = editor_mode;
     editor_mode = 8;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_m256to40:
     {
      int i,j;
      unsigned long k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         mask_convert(256,40,&the_mask[j][i]);
      }
     i = editor_mode;
     editor_mode = 40;
     update_demo();
     editor_mode = i;
     }

    break;


/*************************/

    case lit_4to8:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i+=2)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(4,8,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 8;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_4to40:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(4,40, &the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 40;
     update_demo();
     editor_mode = i;
     }

    break;


    case lit_4to256:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(4,256,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 256;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_8to40:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(8,40,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 40;
     update_demo();
     editor_mode = i;
     }

    break;
    case lit_8to4:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(8,4,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 4;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_8to256:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(8,256,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 256;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_40to8:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i+=2)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(40,8,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 8;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_40to4:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(40,4,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 4;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_40to256:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(40,256, &the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 256;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_256to4:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(256,4,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 4;
     update_demo();
     editor_mode = i;
     }

    break;


    case lit_256to8:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i+=2)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(256,8,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 8;
     update_demo();
     editor_mode = i;
     }

    break;
    case lit_256to40:
     {
      int i,j;
      unsigned short k;
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         color_convert(256,40,&the_sprite[j][i]);
      }
     i = editor_mode;
     editor_mode = 40;
     update_demo();
     editor_mode = i;
     }

    break;

    case lit_c2m:
     {
      int i,j;
      unsigned long partie,dummy,keep,ecrase;
      colorpattern(editor_mode,&dummy,&partie);
      maskpattern(editor_mode,&keep,&ecrase);
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         if (the_sprite[j][i]& partie)
         {
           the_mask[j][i] |= ecrase;
         } else
         {
           the_mask[j][i] &= keep;
         }
      }
      update_demo();
    }
     break;

    case lit_w2m:
     {
      int i,j;
      unsigned long partie,dummy,keep,ecrase;
      colorpattern(editor_mode,&dummy,&partie);
      maskpattern(editor_mode,&keep,&ecrase);
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         if ((the_sprite[j][i]& partie)==partie )
         {
           the_mask[j][i] &= keep;
         } else
         {
           the_mask[j][i] |= ecrase;
         }
      }
      update_demo();
    }
     break;


    case lit_invmask:
     {
      int i,j;
      unsigned long keep,ecrase;
      maskpattern(editor_mode,&keep,&ecrase);
      for(i=0;i<GRIDX;i++)
      for(j=0;j<GRIDY;j++)
      {
         if (the_mask[j][i]& ecrase )
         {
           the_mask[j][i] &= keep;
         } else
         {
           the_mask[j][i] |= ecrase;
         }
      }
      update_demo();
    }
     break;
    case lit_invcol:
     {
      int i,j,k,l,a,b;
      unsigned long keep,ecrase;
      colorpattern(editor_mode,&keep,&ecrase);
      a=min(top,bottom);
      b=top+bottom-a;
      k=min(lefti,righti);
      l=lefti+righti-k;
      for(i=k;i<l;i++)
      for(j=a;j<b;j++)
      {
         the_sprite[j][i] ^= ecrase;
      }
      update_demo();
    }
     break;


   case lit_xchange:
     {
     unsigned long k;
     k = xcoul_col;
     xcoul_col = coul_col;
     coul_col = k;
     wm_idraw(wwk,IWXTRA);
     }
     break;

   case lit_replace:
   {
      unsigned long partie,autre,ancien,nouveau;
      int i,j,k,l,a,b;
      switch(editor_mode)
      {
        case 40: nouveau = color_q40(coul_col); break;
        case 4:  nouveau = color_ql4(coul_col); break;
        case 8:  nouveau = color_ql8(coul_col); break;
       case 256:  nouveau = color_256(coul_col); break;
      }
      switch(editor_mode)
      {
        case 40: ancien = color_q40(xcoul_col); break;
        case 4:  ancien = color_ql4(xcoul_col); break;
        case 8:  ancien = color_ql8(xcoul_col); break;
       case 256:  ancien = color_256(xcoul_col); break;
      }


      i=min(top,bottom);
      j=top+bottom-i;
      k=min(lefti,righti);
      l=lefti+righti-k;
      colorpattern(editor_mode,&partie,&autre);
      for(a=i;a<j;a++)
      for(b=k;b<l;b++)
      {
      if ((the_sprite[a][b] & autre) == ancien)
       {
        the_sprite[a][b] &= partie;
        the_sprite[a][b] |= nouveau;
       }

      }
      update_demo();
   }


     break;
   case lit_fill:
   {
      unsigned long partie,dummy;
      int i,j,k,l,a,b;
      i=min(top,bottom);
      j=top+bottom-i;
      k=min(lefti,righti);
      l=lefti+righti-k;
      colorpattern(editor_mode,&partie,&dummy);
      for(a=i;a<j;a++)
      for(b=k;b<l;b++)
      {
      the_sprite[a][b] &= partie;
      switch(editor_mode)
      {
        case 40: the_sprite[a][b] |= color_q40(coul_col); break;
        case 4:  the_sprite[a][b] |= color_ql4(coul_col); break;
        case 8:  the_sprite[a][b] |= color_ql8(coul_col); break;
       case 256:  the_sprite[a][b] |= color_256(coul_col); break;
      }
      }
      update_demo();
   }
   break;

    case lit_colorchoice:
      {
          long qcoul_col;
          if ((qcoul_col = Colour_Select(DefaultColourSet(),coul_col))!= -1)
          {
              coul_col = qcoul_col;
          }
      }
      break;
    case lit_color256:
      {
          long qcoul_col;
          if ((qcoul_col = Colour256_Select(DefaultColourSet(),coul_col))!= -1)
          {
              coul_col = qcoul_col;
          }
      }
      break;
    case lit_bnoir:
         *pM256back = *pQ40back = *pM4back = *pM8back=0;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =0;
         break;
    case lit_bbleu:
         *pM256back = *pQ40back = *pM4back = *pM8back=1;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =1;
         break;
    case lit_brouge:
         *pM256back = *pQ40back = *pM4back = *pM8back=2;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =2;
         break;
    case lit_bmagenta:
         *pM256back = *pQ40back = *pM4back = *pM8back=3;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =3;
         break;
    case lit_bvert:
         *pM256back = *pQ40back = *pM4back = *pM8back=4;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =4;
         break;
    case lit_bcyan:
         *pM256back = *pQ40back = *pM4back = *pM8back=5;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =5;
         break;
    case lit_bjaune:
         *pM256back = *pQ40back = *pM4back = *pM8back=6;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =6;
         break;
    case lit_bblanc:
         *pM256back = *pQ40back = *pM4back = *pM8back=7;
         *(pM256back+1) = *(pQ40back+1) = *(pM4back+1) = *(pM8back+1) =7;
         break;

    default:
      Message_Report(DefaultColourSet(),"To Be Provided\n\nSoon\n\nMay Be...");
      break;
    }
   xcoul256_col = color_q40to256(xcoul_col);
   coul256_col = color_q40to256(coul_col);

   update_couleur();
   update_demo();
   if ((li->item <lit_noir)||(li->item>lit_load))
   {
    wm_idraw(wwk,IWHAUT & IWLARG & IWQ40 & IWQL4 & IWQL8 & IW256);
    wm_wdraw(wwk);
   }
   else
   { wm_idraw(wwk,IWCOLOUR & IWWHITE & IWRED & IWGREEN & IWBLUE);
   }
    lit_reset(wwk,li->item);
    return AHIT_NORMAL;
}


static long QL4(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
   lit_reset(wwk,lit_4);
   editor_mode = 4;
   update_demo();

{ int i;
   wst->litem[lit_colorchoice]=0x11;
   wst->litem[lit_color256]=0x11;
  for(i=lit_noir+8;i<lit_noir+16;i++)
   wst->litem[i]=0x11;
}

   wm_wdraw(wwk);
}
static long Q256(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
   lit_reset(wwk,lit_256);
   editor_mode = 256;
   update_demo();

{ int i;
   wst->litem[lit_color256]=0x01;
   wst->litem[lit_colorchoice]=0x11;
  for(i=lit_noir+8;i<lit_noir+16;i++)
   wst->litem[i]=0x01;
}

   wm_wdraw(wwk);
}

static long QL8(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
   lit_reset(wwk,lit_8);
   lefti &= 0xFE;
   righti = (righti +1) &0xFE;
   editor_mode = 8;
   update_dimension();
   update_demo();
{ int i;
   wst->litem[lit_color256]=0x11;
   wst->litem[lit_colorchoice]=0x11;
  for(i=lit_noir+8;i<lit_noir+16;i++)
  wst->litem[i]=0x11;
}

   wm_wdraw(wwk);
}


static long Q40(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
   lit_reset(wwk,lit_Q);
   editor_mode = 40;
   update_demo();
{ int i;
   wst->litem[lit_color256]=0x01;
   wst->litem[lit_colorchoice]=0x01;
  for(i=lit_noir+8;i<lit_noir+16;i++)
   wst->litem[i]=0x01;
}

   wm_wdraw(wwk);
}

static long SAVE(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
char name[32];
FILE * fd;
char filenam[50];
char sta[4]= {0x0,0x0,0x0,0x0};
char moda  = 0;
   if (Get_NativeForm() != 0x0221) { sta[2] = 0x11; }

   if (String_Edit(DefaultColourSet(),mess[MS_FIL_T][conf_lang],mess[MS_FIL_E][conf_lang],"",48,filenam)>0)
   if (String_Edit(DefaultColourSet(),mess[MS_SPR_T][conf_lang],mess[MS_SPR_E][conf_lang],"",30,name)>0)
   if (List_Select(DefaultColourSet(),mess[MS_VERS_T][conf_lang],mess[MS_VERS_E][conf_lang],4,sta,mess[MS_M4][conf_lang],mess[MS_M8][conf_lang],
                                      mess[MS_M40][conf_lang],mess[MS_M256][conf_lang]
              )>0)
   {
   fd = fopen(filenam,"r");
   if (fd)
   {

      fclose(fd);
      if (0 != XDialog(DefaultColourSet(),mess[MS_OVER_T][conf_lang],mess[MS_OVER_E][conf_lang],&spdanger,0))
      {
      return lit_reset(wwk,lit_save);
      }
   }
   fd = fopen(filenam,"w");
   if (fd)
   {
   if (sta[0] & 0x80 ) { moda |= 2; }
   if (sta[1] & 0x80 ) { moda |= 1; }
   if (sta[2] & 0x80 ) { moda |= 4; }
   if (sta[3] & 0x80 ) { moda |= 8; }
   switch(conf_qmacas68)
     {
      case 0: write_demo(moda,name,fd); break;
      case 1: write_demo_as68(moda,name,fd); break;
     }
   fclose(fd);
   Message_Report(DefaultColourSet(),mess[MS_SAVE_M][conf_lang]);

   }
   else
   {
     Message_Report(DefaultColourSet(),mess[MS_FILEP_M][conf_lang]);
   }
  }
   lit_reset(wwk,lit_save);
 
}


static long SAVEB(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
FILE * fd;
char filenam[50];
char sta[4]= {0x0,0x0,0x0,0x0};
char moda  = 0;
   if (Get_NativeForm() != 0x0221) { sta[2] = 0x11; }

   if (String_Edit(DefaultColourSet(),mess[MS_FIL_T][conf_lang],mess[MS_FIL_E][conf_lang],"",48,filenam)>0)
   if (List_Select(DefaultColourSet(),mess[MS_VERS_T][conf_lang],mess[MS_VERS_E][conf_lang],4,sta,mess[MS_M4][conf_lang],mess[MS_M8][conf_lang],
                                      mess[MS_M40][conf_lang],mess[MS_M256][conf_lang]
              )>0)
   {
   fd = fopen(filenam,"rb");
   if (fd)
   {

      fclose(fd);
      if (0 != XDialog(DefaultColourSet(),mess[MS_OVER_T][conf_lang],mess[MS_OVER_E][conf_lang],&spdanger,0))
      {
      return lit_reset(wwk,lit_save);
      }
   }
   fd = fopen(filenam,"wb");
   if (fd)
   {
   if (sta[0] & 0x80 ) { moda |= 2; }
   if (sta[1] & 0x80 ) { moda |= 1; }
   if (sta[2] & 0x80 ) { moda |= 4; }
   if (sta[3] & 0x80 ) { moda |= 8; }
   write_demo_bin(moda,fd);
   fclose(fd);
   Message_Report(DefaultColourSet(),mess[MS_SAVE_M][conf_lang]);

   }
   else
   {
     Message_Report(DefaultColourSet(),mess[MS_FILEP_M][conf_lang]);
   }
  }
   lit_reset(wwk,lit_save);
 
}
static long LOAD(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
char name[12];
FILE * fd;
int fd1;
char filenam[50];
char sta[4]= {0x0,0x0,0x0,0x0};
char moda  = 0;

   if (Get_NativeForm() != 0x0221) { sta[2] = 0x11; }

   if (String_Edit(DefaultColourSet(),mess[MS_FIL_T][conf_lang],mess[MS_FILL_E][conf_lang],"",48,filenam)>0)
   if (List_Select(DefaultColourSet(),mess[MS_VERS_T][conf_lang],mess[MS_VERL_E][conf_lang],4,sta,mess[MS_M4][conf_lang],mess[MS_M8][conf_lang],mess[MS_M40][conf_lang],mess[MS_M256][conf_lang])>0)
   {
   fd1 = open(filenam,O_RDONLY);
   fd = fdopen(fd1,"rb");
   if (fd)
   {
   if (sta[0] & 0x80) { moda |= 2; }
   if (sta[1] & 0x80) { moda |= 1; }
   if (sta[2] & 0x80) { moda |= 4; }
   if (sta[3] & 0x80) { moda |= 8; }
   read_demo(moda,fd,fd1);
   fclose(fd);
   wm_wdraw(wwk);

   }
   else
   {
     Message_Report(DefaultColourSet(),mess[MS_FILEP_M][conf_lang]);
   }
  }
   lit_reset(wwk,lit_load);
 
}

static long LOADQ(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
FILE * fd;
int fd1;
char filenam[50];

   if (String_Edit(DefaultColourSet(),mess[MS_FIL_T][conf_lang],mess[MS_FILL_E][conf_lang],"",48,filenam)>0)
   {
   fd1 = open(filenam,O_RDONLY);
   fd = fdopen(fd1,"rb");
   if (fd)
   {
   read_qpic(fd,fd1);
   fclose(fd);
   wm_wdraw(wwk);

   }
   else
   {
     Message_Report(DefaultColourSet(),mess[MS_FILEP_M][conf_lang]);
   }
  }
   lit_reset(wwk,lit_load);
 
}
static long LOADM(struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
FILE * fd;
int fd1;
char filenam[50];

   if (String_Edit(DefaultColourSet(),mess[MS_FIL_T][conf_lang],mess[MS_FILL_E][conf_lang],"",48,filenam)>0)
   {
   fd1 = open(filenam,O_RDONLY);
   fd = fdopen(fd1,"rb");
   if (fd)
   {
   read_mqpic(fd,fd1);
   fclose(fd);
   wm_wdraw(wwk);

   }
   else
   {
     Message_Report(DefaultColourSet(),mess[MS_FILEP_M][conf_lang]);
   }
  }
   lit_reset(wwk,lit_load);
 
}


static long AHIT0(wwk,apw,wst) WM_wwork_t *wwk; WM_appw_t *apw;
                           WM_wstat_t *wst;
{
   int x,y;
   unsigned long transfer;
   unsigned long partie,mas,dummy;
   unsigned short map;
   x= wst->xpos/CASEX;
   y= wst->ypos/CASEY;
   if ((x>=GRIDX)||(y>=GRIDY))
   {
      return AHIT_NORMAL;
   }
   if (editor_mode == 8) { x &= 0xFE; }
    /*  wm_swdef(wwk,apw,wwk->chid);*/

   if ((wst->kprs==K_DO))
   {
    wm_swdef(wwk,apw,wwk->chid);

    if (sprite_with_mask)
     {
      maskpattern(editor_mode,&mas,&dummy);
      the_mask[y][x] &= mas;

      iop_wblb(wwk->chid,-1,x*CASEX+1,y*CASEY+1,&ms40_blob,&ms40_unset);
       if (editor_mode == 8)
      {
      iop_wblb(wwk->chid,-1,(x+1)*CASEX+1,y*CASEY+1,&ms40_blob,&ms40_unset);
      }
      update_demo();
      wm_swapp(wwk,0,CL_WINK);
      switch(editor_mode)
      {
      case 4: wm_idraw(wwk,IWQL4); break;
      case 8: wm_idraw(wwk, IWQL8); break;
      case 40: wm_idraw(wwk,IWQ40 ); break;
      case 256: wm_idraw(wwk, IW256); break;
      }
     }
     else
     {
        switch(editor_mode)
        {
         case 256:

                  coul_col = color_256toq40(the_sprite[y][x]);
              break;
         case 40: coul_col = color_q40toq40(the_sprite[y][x]); break;
         case 8: coul_col = color_8toq40(the_sprite[y][x]); break;
         case 4: coul_col = color_4toq40(the_sprite[y][x]); break;
             }
       coul256_col = color_q40to256(coul_col);

       update_couleur();
       wm_idraw(wwk,IWCOLOUR & IWWHITE & IWRED & IWGREEN & IWBLUE);
       }
   }
if ((wst->kprs==K_HIT))
   {
   wm_swdef(wwk,apw,wwk->chid);

   if (!sprite_with_mask)
      {
      colorpattern(editor_mode,&partie,&dummy);
      the_sprite[y][x] &= partie;
      switch(editor_mode)
      {
        case 40: the_sprite[y][x] |= color_q40(coul_col); break;
        case 4:  the_sprite[y][x] |= color_ql4(coul_col); break;
        case 8:  the_sprite[y][x] |= color_ql8(coul_col);
          une_case(wwk,x,y);
          x++;
         the_sprite[y][x] &= partie;
         the_sprite[y][x] |= color_ql8(coul_col); break;
       case 256:  the_sprite[y][x] |= color_256(coul_col); break;
      }


       update_demo();
       une_case(wwk,x,y);
       wm_swapp(wwk,0,CL_WINK);

      /* ADRAW0(wwk,apw); */
      switch(editor_mode)
      {
      case 4: wm_idraw(wwk,IWQL4); break;
      case 8: wm_idraw(wwk, IWQL8); break;
      case 40: wm_idraw(wwk,IWQ40 ); break;
      case 256: wm_idraw(wwk, IW256); break;
      }

      }

      else
      {
      switch(editor_mode)
       {
       case 40:
      the_mask[y][x] |= 0xFFFF0000;
      break;
      case 256:
      the_mask[y][x] |= 0x0000FF00;
      break;
      case 8:
      the_mask[y][x] |=  0x000000F0 ;
      break;
      default:
      the_mask[y][x] |= 0x0000000F;
      break;
     }
      iop_wblb(wwk->chid,-1,x*CASEX+1,y*CASEY+1,&ms40_blob,&ms40_set);
      if (editor_mode == 8)
      {
      iop_wblb(wwk->chid,-1,(x+1)*CASEX+1,y*CASEY+1,&ms40_blob,&ms40_set);
      }
      update_demo();
      wm_swapp(wwk,0,CL_WINK);

      switch(editor_mode)
      {
      case 4: wm_idraw(wwk,IWQL4); break;
      case 8: wm_idraw(wwk, IWQL8); break;
      case 40: wm_idraw(wwk,IWQ40 ); break;
      case 256: wm_idraw(wwk, IW256); break;
      }

      }
   }
   return AHIT_NORMAL;
}


static long AHIT1(wwk,apw,wst) WM_wwork_t *wwk; WM_appw_t *apw;
                           WM_wstat_t *wst;
{
   if ((wst->kprs==K_HIT)||(wst->kprs==K_DO))
   {
      sprite_with_mask ^= 1;
      wm_wdraw(wwk);

   }
   return AHIT_NORMAL;
}
