#include <stdlib.h>
#include <stdio.h>
#include <qdos.h>
#include <qptr.h>
#include <string.h>
#include <libsprt.h>
#include <xmenu.h>

#include "main.h"
#include "demo.h"
#include "couleur.h"
#include "multilang.h"

#define min(a,b) ((a)<(b)?(a):(b))

extern int mode8_left,mode8_top;

void write_demo(char moda, char * nom, FILE * fd)
{
short a,b;
unsigned int round;
unsigned int mx,my;
int i,j;
int cursor;
fprintf(fd,"%s",mess[MS_SCREER][conf_lang]);
fprintf(fd,"*\n*\n*\n*\n");

fprintf(fd,"     section sprite\n   XDEF _%s\n;\n",nom);
fprintf(fd,"_%s\n",nom);
if (moda & 4)
{
a=sp40_xsize;
b=sp40_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT_M][conf_lang]);
   return;
 }
fprintf(fd,"%s0\n        dc.w $0221,$0000\n",nom);
fprintf(fd,"        dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"        dc.l q40_patt-*\n");
fprintf(fd,"        dc.l q40_mask-*\n");
switch(moda & 11)
{
   case 0: fprintf(fd,"        dc.l 0\n"); break;
   case 1: fprintf(fd,"        dc.l %s8-*\n",nom); break;
   case 8:
   case 9:
   case 10:
   case 11:fprintf(fd,"        dc.l %s6-*\n",nom); break;
   default : fprintf(fd,"        dc.l %s4-*\n",nom); break;
}
fprintf(fd,"q40_patt\n");
round = (a+1) & 0xFFFE;
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=2)
{
  fprintf(fd,"        dc.w $%04x,$%04x\n",sp40_dpatt[cursor],
                                          sp40_dpatt[cursor+1]);

  cursor+=2;

}
fprintf(fd,"q40_mask\n");
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=2)
{
  fprintf(fd,"        dc.w $%04x,$%04x\n",sp40_dmask[cursor],
                                          sp40_dmask[cursor+1]);

  cursor+=2;
}

}
if (moda & 8)
{
a=sp256_xsize;
b=sp256_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT_M][conf_lang]);
   return;
 }
fprintf(fd,"%s6\n        dc.w $0210,$0000\n",nom);
fprintf(fd,"        dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"        dc.l q256_patt-*\n");
fprintf(fd,"        dc.l q256_mask-*\n");
switch(moda & 3)
{
   case 0: fprintf(fd,"        dc.l 0\n"); break;
   case 1: fprintf(fd,"        dc.l %s8-*\n",nom); break;
   default : fprintf(fd,"        dc.l %s4-*\n",nom); break;
}
fprintf(fd,"q256_patt\n");
round = (a+3) & 0xFFFC;
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=4)
{
  fprintf(fd,"        dc.w $%02x%02x,$%02x%02x\n",sp256_dpatt[cursor],
         sp256_dpatt[cursor+1],sp256_dpatt[cursor+2],sp256_dpatt[cursor+3]);

  cursor+=4;

}
fprintf(fd,"q256_mask\n");
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=4)
{
  fprintf(fd,"        dc.w $%02x%02x,$%02x%02x\n",sp256_dmask[cursor],
    sp256_dmask[cursor+1],sp256_dmask[cursor+2],sp256_dmask[cursor+3]);

  cursor+=4;
}

}

if (moda & 2)
{
a=sp4_xsize;
b=sp4_ysize;
fprintf(fd,"%s4",nom);
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT4_M][conf_lang]);
   return;
 }
fprintf(fd,"     dc.w $0100,0000\n");
fprintf(fd,"     dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"     dc.l ql4_patt-*\n");
fprintf(fd,"     dc.l ql4_mask-*\n");
if (moda & 1)
{
fprintf(fd,"     dc.l %s8-*\n",nom);
} else {
fprintf(fd,"     dc.l 0\n");
}
round = (a+15) & 0xFFF0;
round /= 8;
fprintf(fd,"ql4_patt\n");
for(cursor=0;cursor<round*b;cursor+=2)
{
  fprintf(fd,"      dc.w $%04x,$%04x\n",sp4_dpatt[cursor],sp4_dpatt[cursor+1]);
}
fprintf(fd,"ql4_mask\n");
for(cursor=0;cursor<round*b;cursor+=2)
{
  fprintf(fd,"      dc.w $%04x,$%04x\n",sp4_dmask[cursor],sp4_dmask[cursor+1]);
}
}
if (moda & 1)
{

unsigned short cok[2];
int i,j;
a=sp8_xsize;
b=sp8_ysize;
fprintf(fd,"%s8\n",nom);
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT8_M][conf_lang]);
   return;
 }
fprintf(fd,"     dc.w $0101,0000\n");
fprintf(fd,"     dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"     dc.l ql8_patt-*\n");
fprintf(fd,"     dc.l ql8_mask-*\n");
fprintf(fd,"     dc.l 0\n");
fprintf(fd,"ql8_patt\n");
round = (a+15) & 0xFFF0;
round /= 8;
for(j=mode8_top;j<mode8_top+b;j++)
for(cursor=0;cursor<round;cursor+=2)
{
 cok[0]=cok[1]=0;
 for(i=0;i<4;i++)
 {
     if (8*cursor+i*2 < a)
     {
     /* Green bit */
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0040)>>6)<<(15-2*i));
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0020)>>4)<<(6-2*i));
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0010)>>4)<<(6-2*i));
     }
     if (8*cursor+i*2+8 < a)
     {
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0040)>>6)<<(15-2*i));
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0020)>>4)<<(6-2*i));
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0010)>>4)<<(6-2*i));
     }
 }
 fprintf(fd,"       dc.w $%04x,$%04x\n",cok[0],cok[1]);
}
fprintf(fd,"ql8_mask\n");
for(j=mode8_top;j<mode8_top+b;j++)
for(cursor=0;cursor<round;cursor+=2)
{
 cok[0]=cok[1]=0;
 for(i=0;i<4;i++)
 {
  if ((the_mask[j][mode8_left+8*cursor+i*2] & 0x000000F0)&&(8*cursor+i*2 < a))
   {
      cok[0] |=  (0x0303<<(6-2*i));
   }
  if ((the_mask[j][mode8_left+8*cursor+i*2+8] & 0x000000F0)&&(8*cursor+i*2+8 <a))
   {
      cok[1] |=  (0x0303<<(6-2*i));
   }
 }
 fprintf(fd,"       dc.w $%04x,$%04x\n",cok[0],cok[1]);
}
}
fprintf(fd,"     END\n");
}


void write_demo_as68(char moda, char * nom, FILE * fd)
{
short a,b;
unsigned int round;
unsigned int mx,my;
int i,j;
int cursor;
fprintf(fd,"%s",mess[MS_SCREER][conf_lang]);
fprintf(fd,"*\n*\n*\n*\n");

fprintf(fd,"     .sect .data\n   .extern _%s\n;\n",nom);
fprintf(fd,"_%s:\n",nom);
if (moda & 4)
{
a=sp40_xsize;
b=sp40_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT_M][conf_lang]);
   return;
 }
round = (a+1) & 0xFFFE;
fprintf(fd,"%s0:\n        dc.w $0221,$0000\n",nom);
fprintf(fd,"        dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"        dc.l %d; q40_patt-*\n",12);
fprintf(fd,"        dc.l %d; q40_mask-*\n",8+round*b*2);
switch(moda & 11)
{
   case 0: fprintf(fd,"        dc.l 0\n"); break;
   case 1: fprintf(fd,"        dc.l %d; %s8-*\n",4+2*round*b*2,nom); break;
   case 8:
   case 9:
   case 10:
   case 11: fprintf(fd,"        dc.l %d; %s6-*\n",4+2*round*b*2,nom); break;
   default : fprintf(fd,"        dc.l %d; %s4-*\n",4+2*round*b*2,nom); break;
}
fprintf(fd,"q40_patt:\n");
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=2)
{
  fprintf(fd,"        dc.w $%04x,$%04x\n",sp40_dpatt[cursor],
                                          sp40_dpatt[cursor+1]);

  cursor+=2;

}
fprintf(fd,"q40_mask:\n");
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=2)
{
  fprintf(fd,"        dc.w $%04x,$%04x\n",sp40_dmask[cursor],
                                          sp40_dmask[cursor+1]);

  cursor+=2;
}

}

if (moda & 8)
{
a=sp256_xsize;
b=sp256_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT_M][conf_lang]);
   return;
 }
round = (a+3) & 0xFFFC;
fprintf(fd,"%s6:\n        dc.w $0210,$0000\n",nom);
fprintf(fd,"        dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"        dc.l %d; q256_patt-*\n",12);
fprintf(fd,"        dc.l %d; q256_mask-*\n",8+round*b);
switch(moda & 3)
{
   case 0: fprintf(fd,"        dc.l 0\n"); break;
   case 1: fprintf(fd,"        dc.l %d; %s8-*\n",4+round*b*2,nom); break;
   default : fprintf(fd,"        dc.l %d; %s4-*\n",4+round*b*2,nom); break;
}
fprintf(fd,"q256_patt:\n");
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=4)
{
  fprintf(fd,"        dc.w $%02x%02x,$%02x%02x\n",sp256_dpatt[cursor],
     sp256_dpatt[cursor+1],sp256_dpatt[cursor+2],sp256_dpatt[cursor+3]);

  cursor+=4;

}
fprintf(fd,"q256_mask:\n");
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=4)
{
  fprintf(fd,"        dc.w $%02x%02x,$%02x%02x\n",sp256_dmask[cursor],
      sp256_dmask[cursor+1],sp256_dmask[cursor+2],sp256_dmask[cursor+3]);

  cursor+=4;
}

}


if (moda & 2)
{
a=sp4_xsize;
b=sp4_ysize;
fprintf(fd,"%s4:",nom);
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT4_M][conf_lang]);
   return;
 }
round = (a+15) & 0xFFF0;
round /= 8;
fprintf(fd,"     dc.w $0100,0000\n");
fprintf(fd,"     dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"     dc.l %d; ql4_patt-*\n",12);
fprintf(fd,"     dc.l %d; ql4_mask-*\n",8+2*round*b);
if (moda & 1)
{
fprintf(fd,"     dc.l %d; %s8-*\n",4+2*round*b*2,nom);
} else {
fprintf(fd,"     dc.l 0\n");
}
fprintf(fd,"ql4_patt:\n");
for(cursor=0;cursor<round*b;cursor+=2)
{
  fprintf(fd,"      dc.w $%04x,$%04x\n",sp4_dpatt[cursor],sp4_dpatt[cursor+1]);
}
fprintf(fd,"ql4_mask:\n");
for(cursor=0;cursor<round*b;cursor+=2)
{
  fprintf(fd,"      dc.w $%04x,$%04x\n",sp4_dmask[cursor],sp4_dmask[cursor+1]);
}
}
if (moda & 1)
{

unsigned short cok[2];
int i,j;
a=sp8_xsize;
b=sp8_ysize;
fprintf(fd,"%s8:\n",nom);
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT8_M][conf_lang]);
   return;
 }
round = (a+15) & 0xFFF0;
round /= 8;
fprintf(fd,"     dc.w $0101,0000\n");
fprintf(fd,"     dc.w %d,%d,0,0\n",a,b);
fprintf(fd,"     dc.l %d; ql8_patt-*\n",12);
fprintf(fd,"     dc.l %d; ql8_mask-*\n",8+2*b*round);
fprintf(fd,"     dc.l 0\n");
fprintf(fd,"ql8_patt:\n");
for(j=mode8_top;j<mode8_top+b;j++)
for(cursor=0;cursor<round;cursor+=2)
{
 cok[0]=cok[1]=0;
 for(i=0;i<4;i++)
 {
     if (8*cursor+i*2 < a)
     {
     /* Green bit */
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0040)>>6)<<(15-2*i));
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0020)>>4)<<(6-2*i));
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0010)>>4)<<(6-2*i));
     }
     if (8*cursor+i*2+8 < a)
     {
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0040)>>6)<<(15-2*i));
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0020)>>4)<<(6-2*i));
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0010)>>4)<<(6-2*i));
     }
 }
 fprintf(fd,"       dc.w $%04x,$%04x\n",cok[0],cok[1]);
}
fprintf(fd,"ql8_mask:\n");
for(j=mode8_top;j<mode8_top+b;j++)
for(cursor=0;cursor<round;cursor+=2)
{
 cok[0]=cok[1]=0;
 for(i=0;i<4;i++)
 {
  if ((the_mask[j][mode8_left+8*cursor+i*2] & 0x0000FF00)&&(8*cursor+i*2 < a))
   {
      cok[0] |=  (0x0303<<(6-2*i));
   }
  if ((the_mask[j][mode8_left+8*cursor+i*2+8] & 0x0000FF00)&&(8*cursor+i*2+8 <a))
   {
      cok[1] |=  (0x0303<<(6-2*i));
   }
 }
 fprintf(fd,"       dc.w $%04x,$%04x\n",cok[0],cok[1]);
}
}
fprintf(fd,"; END");
}

void write_demo_bin(char moda, FILE * fd)
{
short a,b;
unsigned int round;
unsigned int mx,my;
int i,j;
int cursor;
long dumbo;
if (moda & 4)
{
a=sp40_xsize;
b=sp40_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT_M][conf_lang]);
   return;
 }
round = (a+1) & 0xFFFE;
fprintf(fd,"%c%c%c%c", 0x02, 0x21,00,00);
fprintf(fd,"%c%c%c%c%c%c%c%c",0,a,0,b,0,0,0,0);
fprintf(fd,"%c%c%c%c",0,0,0,12);
dumbo=(8+round*b*2);
fprintf(fd,"%c%c%c%c",0x0FF & (dumbo>>24),0x0FF & (dumbo>>16),0x0FF & (dumbo>>8), 0x0FF & (dumbo));
switch(moda & 11)
{
   case 0: fprintf(fd,"%c%c%c%c",0,0,0,0); break;
   default:
dumbo = 4+2*round*b*2;
fprintf(fd,"%c%c%c%c",0x0FF & (dumbo>>24),0x0FF & (dumbo>>16),0x0FF & (dumbo>>8), 0x0FF & (dumbo));
           break;
}
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=2)
{
  fprintf(fd,"%c%c%c%c",0x0FF &(sp40_dpatt[cursor] >> 8),0x0FF & (sp40_dpatt[cursor]),
           0x0FF & (sp40_dpatt[cursor+1] >> 8),0x0FF & ( sp40_dpatt[cursor+1]));

  cursor+=2;

}
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=2)
{
  fprintf(fd,"%c%c%c%c",0x0FF &(sp40_dmask[cursor] >> 8),0x0FF & (sp40_dmask[cursor]),
           0x0FF & (sp40_dmask[cursor+1] >> 8),0x0FF & ( sp40_dmask[cursor+1]));

  cursor+=2;
}

}

if (moda & 8)
{
a=sp256_xsize;
b=sp256_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT_M][conf_lang]);
   return;
 }
round = (a+3) & 0xFFFC;
fprintf(fd,"%c%c%c%c", 0x02,0x10,00,00);
fprintf(fd,"%c%c%c%c%c%c%c%c",0,a,0,b,0,0,0,0);
fprintf(fd,"%c%c%c%c",0,0,0,12);
dumbo=8+round*b;
fprintf(fd,"%c%c%c%c",0x0FF & (dumbo>>24),0x0FF & (dumbo>>16),0x0FF & (dumbo>>8), 0x0FF & (dumbo));
switch(moda & 3)
{
   case 0: fprintf(fd,"%c%c%c%c",0,0,0,0); break;
   default :
dumbo=4+round*b*2;
fprintf(fd,"%c%c%c%c",0x0FF & (dumbo>>24),0x0FF & (dumbo>>16),0x0FF & (dumbo>>8), 0x0FF & (dumbo));
 break;
}
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=4)
{
  fprintf(fd,"%c%c%c%c",sp256_dpatt[cursor],
     sp256_dpatt[cursor+1],sp256_dpatt[cursor+2],sp256_dpatt[cursor+3]);

  cursor+=4;

}
cursor = 0;
for(j=0;j<b;j++)
for(i=0;i<round;i+=4)
{
  fprintf(fd,"%c%c%c%c",sp256_dmask[cursor],
      sp256_dmask[cursor+1],sp256_dmask[cursor+2],sp256_dmask[cursor+3]);

  cursor+=4;
}

}


if (moda & 2)
{
a=sp4_xsize;
b=sp4_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT4_M][conf_lang]);
   return;
 }
round = (a+15) & 0xFFF0;
round /= 8;
fprintf(fd,"%c%c%c%c",01,00,00,00);
fprintf(fd,"%c%c%c%c%c%c%c%c",0,a,0,b,0,0,0,0);
fprintf(fd,"%c%c%c%c",0,0,0,12);
dumbo=8+2*round*b;
fprintf(fd,"%c%c%c%c",0x0FF & (dumbo>>24),0x0FF & (dumbo>>16),0x0FF & (dumbo>>8), 0x0FF & (dumbo));
if (moda & 1)
{
dumbo=4+2*round*b*2;
fprintf(fd,"%c%c%c%c",0x0FF & (dumbo>>24),0x0FF & (dumbo>>16),0x0FF & (dumbo>>8), 0x0FF & (dumbo));
} else {
fprintf(fd,"%c%c%c%c",0,0,0,0);
}
for(cursor=0;cursor<round*b;cursor+=2)
{
  fprintf(fd,"%c%c%c%c",0x0FF &(sp4_dpatt[cursor] >> 8),0x0FF & (sp4_dpatt[cursor]),
           0x0FF & (sp4_dpatt[cursor+1] >> 8),0x0FF & ( sp4_dpatt[cursor+1]));
}
for(cursor=0;cursor<round*b;cursor+=2)
{
  fprintf(fd,"%c%c%c%c",0x0FF &(sp4_dmask[cursor] >> 8),0x0FF & (sp4_dmask[cursor]),
           0x0FF & (sp4_dmask[cursor+1] >> 8),0x0FF & ( sp4_dmask[cursor+1]));
}
}
if (moda & 1)
{

unsigned short cok[2];
int i,j;
a=sp8_xsize;
b=sp8_ysize;
if ((!a)||(!b))
 {
   fprintf(fd,"%s",mess[MS_NSPRT][conf_lang]);
   Message_Report(DefaultColourSet(),mess[MS_NSPRT8_M][conf_lang]);
   return;
 }
round = (a+15) & 0xFFF0;
round /= 8;
fprintf(fd,"%c%c%c%c",01,01,00,00);
fprintf(fd,"%c%c%c%c%c%c%c%c",0,a,0,b,0,0,0,0);
fprintf(fd,"%c%c%c%c",0,0,0,12);
dumbo=8+2*b*round;
fprintf(fd,"%c%c%c%c",0x0FF & (dumbo>>24),0x0FF & (dumbo>>16),0x0FF & (dumbo>>8), 0x0FF & (dumbo));
fprintf(fd,"%c%c%c%c",0,0,0,0);
for(j=mode8_top;j<mode8_top+b;j++)
for(cursor=0;cursor<round;cursor+=2)
{
 cok[0]=cok[1]=0;
 for(i=0;i<4;i++)
 {
     if (8*cursor+i*2 < a)
     {
     /* Green bit */
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0040)>>6)<<(15-2*i));
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0020)>>4)<<(6-2*i));
     cok[0] |= (((the_sprite[j][mode8_left+8*cursor+i*2] & 0x0010)>>4)<<(6-2*i));
     }
     if (8*cursor+i*2+8 < a)
     {
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0040)>>6)<<(15-2*i));
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0020)>>4)<<(6-2*i));
     cok[1] |= (((the_sprite[j][mode8_left+8*cursor+i*2+8] & 0x0010)>>4)<<(6-2*i));
     }
 }
  fprintf(fd,"%c%c%c%c",0x0FF &(cok[0] >> 8),0x0FF & (cok[0]),
           0x0FF & (cok[1] >> 8),0x0FF & ( cok[1]));

}
for(j=mode8_top;j<mode8_top+b;j++)
for(cursor=0;cursor<round;cursor+=2)
{
 cok[0]=cok[1]=0;
 for(i=0;i<4;i++)
 {
  if ((the_mask[j][mode8_left+8*cursor+i*2] & 0x0000FF00)&&(8*cursor+i*2 < a))
   {
      cok[0] |=  (0x0303<<(6-2*i));
   }
  if ((the_mask[j][mode8_left+8*cursor+i*2+8] & 0x0000FF00)&&(8*cursor+i*2+8 <a))
   {
      cok[1] |=  (0x0303<<(6-2*i));
   }
 }
  fprintf(fd,"%c%c%c%c",0x0FF &(cok[0] >> 8),0x0FF & (cok[0]),
           0x0FF & (cok[1] >> 8),0x0FF & ( cok[1]));
}
}
}
