#include <stdarg.h>
#include <stdlib.h>
#include <qptr.h>
#include <qdos.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <xmenu.h>
#include <xmenudef.h>
#include <libsprt.h>
#include "couleur.h"
#include "main.h"



static long ADRAWCOL0(wwk,apw) WM_wwork_t *wwk; WM_appw_t *apw;
{
   unsigned int x,y;

   for(x=0;x<=15;x++)
   for(y=0;y<=15;y++)
   {
      coul6_col = coul16_col = x+y*16;
      coul16_col = (coul16_col & 0x0FE)<<8 | (coul16_col & 0x01)<<7;
   coul16_col = ((coul16_col & 0x8000))|((coul16_col & 0x1000)<<2)|((coul16_col & 0x0200)<<4) |
              ((coul16_col & 0x8000)>>3) |( (coul16_col & 0x1000)>>1) |
              ((coul16_col & 0x4000)>>4) |( (coul16_col & 0x0800)>>2) | ((coul16_col & 0x0080)<<1) |
              ((coul16_col & 0x4000)>>7) |( (coul16_col & 0x0800)>>5) |
              ((coul16_col & 0x2000)>>8) |( (coul16_col & 0x0400)>>6) | ((coul16_col & 0x0080)>>4) |
              ((coul16_col & 0x2000)>>11) |( (coul16_col & 0x0400)>>9) |
              ((coul16_col & 0x0080) >> 7);

     if (not_q40)
     {
     iop_wspt(wwk->chid,-1,0,0,&sp_center);
     }
      iop_wblb(wwk->chid,-1,x*32+1,y*16+1,&coul256_blob,&coul256_patt);
   }
   return 0;

}

static long AHITCOL0(wwk,apw,wst) WM_wwork_t *wwk; WM_appw_t *apw; WM_wstat_t *wst;
{
   unsigned short * gogo;
   unsigned short value;

   if (wst->kprs == K_HIT)
   {
     gogo = (unsigned short *)(apw->pstat);
     value= (wst->xpos / 32) + 16 * ((wst->ypos) >>4);
     coul256_col = value;
     value = (value & 0xFE)<<8 | (value & 0x01)<<7;
     coul_col = (value & 0x8000)|(value & 0x1000)<<2|(value & 0x0200)<<4 |
              (value & 0x8000)>>3  | (value & 0x1000)>>1 |
              (value & 0x4000)>>4  | (value & 0x0800)>>2 | (value & 0x0080)<<1 |
              (value & 0x4000)>>7  | (value & 0x0800)>>5 |
              (value & 0x2000)>>8  | (value & 0x0400)>>6 | (value & 0x0080)>>4 |
              (value & 0x2000)>>11 | (value & 0x0400)>>9 |
              (value & 0x0080) >> 7;

     (*gogo) = coul_col;
     *(gogo+1) = *gogo;

     wm_idraw(wwk,0);
     return AHIT_NORMAL;
   }
   if (wst->kprs == K_DO)
   {
      return PT__DO;
   }
   if (wst->kstk == 27)
   {
      wst->evnt |= PT_CAN;
      return PT__CAN;
   }
   return AHIT_NORMAL;
}

static struct WM_action ahitcol0 = { JSR, wm_hitaw, AHITCOL0 };

static struct WM_action adrawcol0 = { JSR, wm_drwaw, ADRAWCOL0 };

/*
**
** Colour_Select : color_code : for paper and ink
**
** return value :
**               -1 : ESC was used to exit the window
**
*/
long Colour256_Select(
                  const colourSet * color_code,
                  unsigned short previous
                  )
{
   short char_size;
   long string_length;
   JG_text * titre;
   JG_text * explain;
   short window_width;
   short item_width;
   short x,y;
   long curs_len;
   long vertical;
   long nitem;
   unsigned short xsize,xoff,ysize,yoff;
   char * anyptr;
   struct WM_wstat *ws; /* this time ws is initialised in code */
   long horizon;
   long i;
   long ret_value;
   long x_expl,y_expl;

   static unsigned short *the_colour;

   static struct WM_info info[1+1] =   /* information objects */
   {
    {24,24,            /* xsize, ysize         size */
     0,0,                   /* xorg, yorg           and origin */
     TYP_BLOB,0,            /* type, spare          item type */
     {0,0,0},         /* ink, cwid, chgt      character attributes */
     &coul_blob}                /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };


   static struct WM_infw infw[2+1] =  /* information window */
   {
    {32,28,          /* xsize, ysize         size */
     512+4+4+16,146,                   /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     1,255,7,                 /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */
,
    {24,24,          /* xsize, ysize         size */
     512+4+4+20,148,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{-1}                    /* end of array */
   };


   static WM_appw_t aw0 = /* application sub-window */
   {
     512,256,  /* xsize, ysize         size */
     4,2,              /* xorg, yorg           and origin */
     0,             /* flag                 no clear + shadow */
     1,0,7,   /* borw, borc, papr     border width/clr, paper */
     NULL,       /* *pspr                pointer to sprite */

     &adrawcol0,                /* *draw                draw routine */
     &ahitcol0,                 /* *hit                 hit routine */
     NULL,                  /* *ctrl                control routine */
     0,0,                   /* nxsc, nysc           max x,y sections */
     K_TAB,0,0,             /* skey, 2 spare        selection keystroke */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     NULL,                      /* *pwcb            part window ctrl block */
     0,0,0,0,0,0,NULL,NULL,     /*                  6 short 2 pointer zero */
     CL_WRROW,CL_WBARB,CL_WBARS,/* psac, psbc, pssc arrow/bar clrs */

     NULL                       /* *pstat               wind status area (C68) */
   };

   static WM_appl_t wappl[1+1]={&aw0,NULL};


   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     wappl,                  /* *splst               pointer to sprite list */

     0,0,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     1,                     /* flag                 no clear + shadow */
     1,0,0,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,0,            /* curw, curc           current item width/clr */

     0,0,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     0,0,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     0,0,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     0,0,NULL,              /* ninfo, ninob, *pinfo info winds */
     0,NULL,                /* nlitm, *plitm        loose items */
     1,wappl                 /* nappl  *pappl        appl winds */
   };
   info[0].attr.comb = &coul_patt;
   ws = malloc(sizeof(struct WM_wstat));

   if (!ws) { return -1; }
   ws->wwork = &ww;
   ww.wstat = ws;

   ws->wdef = NULL;
   ws->chid = 0;
   ws->swnr = 0;
   ws->xpos = 0;
   ws->ypos = 0;
   ws->kstk = 0;
   ws->kprs = 0;
   ws->evnt = 0;
   ws->xsiz = 0;
   ws->ysiz = 0;
   ws->xorg = 0;
   ws->yorg = 0;
   ws->ptpsx = 0;
   ws->ptpsy = 0;
   ws->ciact = NULL;
   ws->citem = -1;
   ws->cibrw = 0;
   ws->cipap = 0;
   ws->cispr = 0;
   ws->cihxs = 0;
   ws->cihys = 0;
   ws->cihxo = 0;
   ws->cihyo = 0;


   ws->wmode = (char_size == 6 ? FORM_QL4 : FORM_QL8);
   /* now, let's get the sprite size */
   xoff=xsize=ysize=yoff=0;
   xsize = (xsize+1) & 0xFFFE;

   the_colour = malloc(2*sizeof(unsigned short));
   if (!the_colour)
   {
       free(ws);
       return -1;
   }
   aw0.pstat = the_colour;

   *the_colour = previous;
   *(the_colour+1) = previous;
   ww.ninfo = 2;
   ww.ninob = 1;
   ww.pinfo = infw;
   ww.borc = color_code->border;
   ww.papr = color_code->paper;
   ww.aback = color_code->paper;
   ww.aink  = color_code->ink;
   ww.sback = color_code->selection_paper;
   ww.sink  = color_code->selection_ink;
   ww.xsize = 512+8+4+4+4+64+4;
   ww.ysize = 260+4;
   ww.xorg = ww.xsize/2;
   ww.yorg = ww.yorg/2;
   ww.curc = color_code->surround ;


   if (!wm_pulld(&ww,-1,-1))
   {

      wm_wdraw(&ww);

      while (!wm_rptr(&ww))
      {
         if (ws->evnt & PT_CAN) break;
         if (ws->evnt & PT_DO) break;
      };
   }
   ret_value = -1;
   if (!(ws->evnt & PT_CAN))
   {
      ret_value = *(the_colour+1);
   }
   else
   {
       coul_col = previous;
   }
   wm_cluns(&ww);

   free(the_colour);
   free(ws);
   return ret_value;

}
